SystemOrganization addCategory: #Squeak2JS!
SystemOrganization addCategory: #'Squeak2JS-Graphics'!
SystemOrganization addCategory: #'Squeak2JS-Graphics-Examples'!
SystemOrganization addCategory: #'Squeak2JS-Tests'!

Object subclass: #JsDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

Object subclass: #JsGlobal
	instanceVariableNames: 'testInstVar do'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!JsGlobal commentStamp: 'lw 12/2/2010 18:43' prior: 0!
JsGlobal is a substitute for the JavaScript Global namespace. In order to call global JavaScript functions like alert, just send them to this Class.!

!JsGlobal methodsFor: 'as yet unclassified' stamp: 'ag 12/13/2010 15:48'!
alert: aString
	"This is mainly for testing"
	
	Transcript cr; show: aString.! !

!JsGlobal methodsFor: 'as yet unclassified' stamp: 'ag 12/22/2010 16:41'!
test
	
	^ do! !

Object subclass: #S2JClassModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

S2JClassModel class
	instanceVariableNames: 'textStream'!

S2JClassModel class
	instanceVariableNames: 'textStream'!

!S2JClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/15/2010 10:48'!
convertClassCodeFrom: anS2JCompiledClass
	
	| output |
	output := self getTextStream.
	self convertClassCodeFrom: anS2JCompiledClass to: output.
	^ output contents! !

!S2JClassModel class methodsFor: 'converting class-definition' stamp: 'ag 1/3/2011 11:41'!
convertClassCodeFrom: anS2JCompiledClass to: output
	"This must be implemented by a class-model - all parts of the class represented by anS2JCompiledClass must be printed to output as JS-code."
	
	"TODO -- how to handle the print-mode (pretty print vs. obfuscation) here? It has already been handled during parsing?.."
	self subclassResponsibility! !

!S2JClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:15'!
getTextStream
	
	textStream ifNil: [ textStream := TextStream on: '' ].
	^ textStream
		reset;
		yourself! !

S2JClassModel subclass: #S2JFullClassModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 1/5/2011 09:59'!
convertClassCodeFrom: source to: output
	"Does not create a class, just a constructor-function, that sets all the functions."
	
	output << source classname << '=Class({'.
	self
		printPart: [self printSuperclass: source to: output] to: output;
		printPart: [self printInstVars: source to: output] to: output;
		printPart: [self printClassVars: source to: output] to: output;
		printPart: [self printClassInstVars: source to: output] to: output;
		printPart: [self printClassMethods: source to: output] to: output;
		printInstanceMethods: source to: output.
	output << '})'.! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/15/2010 10:34'!
print: aCollection named: aString to: output
	
	aCollection
		ifNotEmpty: [
			output << aString << ':['.
			self
				printEach: [ :each | output << '"' << each << '"' ]
				of: aCollection
				separatedBy: ','
				to: output.
			output << ']'.
			^ true]
		ifEmpty: [ ^ false ]! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:41'!
printClassInstVars: source to: output
	
	^ self
		print: source classInstVars
		named: 'classInstanceVariables'
		to: output.! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:41'!
printClassMethods: source to: output
	
	^ self
		printMethods: source classMethods
		named: 'classMethods'
		to: output.! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:41'!
printClassVars: source to: output
	
	^ self
		print: source classVars
		named: 'classVariables'
		to: output.! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:28'!
printEach: aBlock of: aCollection separatedBy: aString to: output
	
	| isFirst |
	isFirst := true.
	aCollection do: [ :each | 
		isFirst
			ifTrue: [ isFirst := false ]
			ifFalse: [ output << ',' ].
		aBlock value: each].! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:41'!
printInstVars: source to: output
	
	^ self
		print: source instVars
		named: 'instanceVariables'
		to: output.! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:42'!
printInstanceMethods: source to: output
	
	^ self
		printMethods: source instMethods
		named: 'instanceMethods'
		to: output.! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:42'!
printMethods: aCollection named: aString to: output
	
	aCollection
		ifNotEmpty: [
			output << aString << ':{'.
			self
				printEach: [ :each | | code | 
					code := each javascriptObject.
					output << code key << ':' << code value ]
				of: aCollection
				separatedBy: ','
				to: output.
			output << '}'.
			^ true]
		ifEmpty: [ ^ false ]! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 12/14/2010 01:43'!
printPart: aBlock to: output
	
	aBlock value ifTrue: [ output << ','].! !

!S2JFullClassModel class methodsFor: 'converting class-definition' stamp: 'ag 1/5/2011 09:53'!
printSuperclass: source to: output
	
	source superclass
		ifNotNil: [
			output << 'superClass:' << source superclass. "Already escaped etc."
			^ true]
		ifNil: [ ^ false ]! !

S2JClassModel subclass: #S2JSimpleClassModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JSimpleClassModel class methodsFor: 'converting class-definition' stamp: 'ag 1/3/2011 11:40'!
convertClassCodeFrom: anS2JCompiledClass to: output
	"Does not create a class, just a constructor-function, that sets all the functions as methods."
	
	output << anS2JCompiledClass classname << '=function(){'.
	anS2JCompiledClass instMethods associationsDo: [ :function | output << 'this.' << function key << '=' << function value].
	output << '}'.! !

Object subclass: #S2JCodeFactory
	instanceVariableNames: 'codeCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

S2JCodeFactory class
	instanceVariableNames: 'instance'!

!S2JCodeFactory commentStamp: 'ag 12/16/2010 12:46' prior: 0!
S2JCodeFactory readAllCodeInImage.

S2JCodeFactory clearCache.

S2JCodeFactory codeCache size. 84964. 64386. " 62492 !!!! ".

S2JCodeFactory codeFor: 'a doit-snippet squeak code'.

S2JCodeFactory  codeForClass: Object.

S2JCodeFactory codeForMethod: #asString of: Object.
!

S2JCodeFactory class
	instanceVariableNames: 'instance'!

!S2JCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/16/2010 11:44'!
destroyInstance
	
	instance := nil.! !

!S2JCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/13/2010 15:43'!
doesNotUnderstand: aMessage
	"removes need to call instance every time the code-factory is accessed"
	
	^ self instance perform: aMessage selector withArguments: aMessage arguments! !

!S2JCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/16/2010 11:09'!
instance
	
	instance ifNil: [ instance := self new ].
	^ instance! !

!S2JCodeFactory methodsFor: 'private' stamp: 'ag 12/15/2010 10:47'!
cacheCodeFor: anObject producedBy: aBlock
	
	^ (self cacheObjectFor: anObject producedBy: aBlock) javascriptObject! !

!S2JCodeFactory methodsFor: 'private' stamp: 'ag 12/22/2010 12:37'!
cacheObjectFor: anObject producedBy: aBlock
	
	| result |
	result := self codeCache at: anObject ifAbsent: [ nil ].
	result
		ifNil: [
			result := aBlock value.
			self codeCache at: anObject put: result.
			result update]
		ifNotNil: [
			result hasChanged ifTrue: [ result update ]].
	^ result! !

!S2JCodeFactory methodsFor: 'private' stamp: 'ag 12/22/2010 12:40'!
cacheObjectForMethod: aCompiledMethod
	"If the code for a method is queried before the code for the whole class, create a stub for the class, that is initialized later."
	
	^ self
		cacheObjectFor: aCompiledMethod
		producedBy: [ | class compiledClass |
			class := aCompiledMethod methodClass.
			compiledClass := self codeCache at: aCompiledMethod ifAbsent: [ nil ].
			compiledClass ifNil: [ 
				compiledClass := S2JCompiledClass from: class inFactory: self.
				self codeCache at: class put: compiledClass ].
			S2JCompiledMethod from: aCompiledMethod inClass: compiledClass ]! !

!S2JCodeFactory methodsFor: 'cache' stamp: 'ag 12/14/2010 00:40'!
cleanupCache
	"Remove all invalid classes/methods from the cache (classes/methods, that have been deleted from the image)"
	
	self codeCache: 
		(self codeCache 
			reject: [ :object | object isValid not ]).! !

!S2JCodeFactory methodsFor: 'cache' stamp: 'ag 12/15/2010 10:42'!
clearCache
	
	self codeCache removeAll.! !

!S2JCodeFactory methodsFor: 'accessing' stamp: 'ag 12/13/2010 14:30'!
codeCache
	^ codeCache! !

!S2JCodeFactory methodsFor: 'accessing' stamp: 'ag 12/13/2010 14:30'!
codeCache: anObject
	codeCache := anObject! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/14/2010 00:37'!
codeFor: aString
	"A simple DoIt-code-snippet"
	
	^ self
		cacheCodeFor: aString
		producedBy: [ S2JCompiledDoIt from: aString ]! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/22/2010 12:40'!
codeForClass: aClassOrClassName
	"A JS-Code-String representing the whole class. Without a DoIt code-snippet etc."
	
	| cl |
	cl := S2JCompiledObject converterClass classNamed: aClassOrClassName.
	^ (self
		cacheCodeFor: cl
		producedBy: [ S2JCompiledClass from: cl inFactory: self ])! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/14/2010 00:37'!
codeForCompiledMethod: aCompiledMethod
	"An association from the function-name to the function-declaration-code"
	
	^ (self cacheObjectForMethod: aCompiledMethod) javascriptObject! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/14/2010 01:17'!
codeForMethod: aMethodSelector of: aClassOrClassName
	
	^ self codeForCompiledMethod:
		(S2JCompiledObject converterClass method: aMethodSelector of: aClassOrClassName)! !

!S2JCodeFactory methodsFor: 'private' stamp: 'ag 12/16/2010 11:47'!
compareCacheKey: o1 to: o2
	"CompiledMethods are considered equal, if they represent the same selector in the same class.
	Even after recompilation of a method, the old instance of CompiledMethod will be kept in the dictionary."
	
	o1 class = o2 class ifFalse: [ ^ false ].
	^ o1 class = CompiledMethod
		ifTrue: [ o1 methodClass = o2 methodClass and: [ o1 selector = o2 selector ] ]
		ifFalse: [ o1 = o2 ]! !

!S2JCodeFactory methodsFor: 'private' stamp: 'ag 1/3/2011 22:19'!
hashCodeFor: anObject
	
	^ anObject class = CompiledMethod
		ifTrue: [ 7 * anObject methodClass hash + anObject selector hash]
		ifFalse: [ anObject hash ]! !

!S2JCodeFactory methodsFor: 'initialization' stamp: 'ag 1/3/2011 22:06'!
initialize
	
	super initialize.
	self codeCache: PluggableDictionary new.
	self codeCache
		equalBlock: [ :o1 :o2 | self compareCacheKey: o1 to: o2 ];
		hashBlock: [ :object | self hashCodeFor: object ].! !

!S2JCodeFactory methodsFor: 'javascript code' stamp: 'ag 12/15/2010 16:28'!
readAllCodeInImage
	"Read each method in the image. This will not throw an error, just skip methods, that cannot be read."
	
	S2JOMeta2 allMethodsDoAndReport: [ :eachMethod |
		self codeForCompiledMethod: eachMethod ].! !

Object subclass: #S2JCompiledObject
	instanceVariableNames: 'squeakObject javascriptObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

S2JCompiledObject subclass: #S2JCompiledClass
	instanceVariableNames: 'codeFactory instMethods classMethods instVars superclass classInstVars classVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JCompiledClass class methodsFor: 'instance creation' stamp: 'ag 12/22/2010 12:40'!
from: aSqueakClass inFactory: aCodeFactory
	
	^ self new
		squeakObject: aSqueakClass;
		codeFactory: aCodeFactory;
		yourself! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classInstVars
	
	^ classInstVars! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classInstVars: anObject
	
	classInstVars := anObject! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classMethods
	
	^ classMethods! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classMethods: anObject
	
	classMethods := anObject! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classVars
	
	^ classVars! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:59'!
classVars: anObject
	
	classVars := anObject! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 1/5/2011 09:54'!
classname
	
	^ S2JSqueakAstToJsAst escapeReservedWord: self squeakObject "#asString of a class gives the classname"! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:38'!
codeFactory
	
	^ codeFactory! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:38'!
codeFactory: aCodeFactory
	
	codeFactory := aCodeFactory! !

!S2JCompiledClass methodsFor: 'converting' stamp: 'ag 12/14/2010 01:04'!
hasChanged
	
	^ 
	((self haveMethodsChanged: self instMethods from: self squeakObject)
	or: [ self haveMethodsChanged: self classMethods from: self squeakObject class ]
	or: [ self superclass ~= self squeakObject superclass name ]
	or: [ self instVars ~= self squeakObject allInstVarNames ]
	or: [ self classInstVars ~= self squeakObject class allInstVarNames ])
	or: [ self classVars ~= self squeakObject allClassVarNames ]! !

!S2JCompiledClass methodsFor: 'converting' stamp: 'ag 12/14/2010 01:11'!
haveMethodsChanged: aCollection from: originalClass
	
	^ 
	aCollection isNil or: [
		(aCollection anySatisfy: 
			[ :method | method isValid not or: [ method hasChanged ]])
		or: [ originalClass methodDict anySatisfy: [ :method | (aCollection includes: method) not ]]]! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:57'!
instMethods
	
	^ instMethods! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:57'!
instMethods: anObject
	
	instMethods := anObject! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
instVars
	
	^ instVars! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
instVars: anObject
	
	instVars := anObject! !

!S2JCompiledClass methodsFor: 'converting' stamp: 'ag 12/13/2010 22:44'!
isValid
	
	^ self squeakObject notNil
		and: [ (Smalltalk classNamed: self squeakObject name) notNil ]! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
superclass
	
	^ superclass! !

!S2JCompiledClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
superclass: aString
	
	superclass := aString! !

!S2JCompiledClass methodsFor: 'converting' stamp: 'ag 1/5/2011 09:50'!
update
	"First set the fields, then do the actual conversion. Errors during the conversion will happen only once,
	the old version of the javascriptObject will be kept if that happens."
	
	Transcript cr; show: 'Compiling class: ', self squeakObject name.
	
	self
		instMethods: (self updateMethodsFrom: self squeakObject);
		classMethods: (self updateMethodsFrom: self squeakObject class);
		superclass: (S2JSqueakAstToJsAst escapeReservedWord: self squeakObject superclass); "#asString of a class gives the classname"
		instVars: (self squeakObject allInstVarNames collect: [ :each | S2JSqueakAstToJsAst escapeCharForIdentifier, each]);
		classInstVars: self squeakObject class allInstVarNames;
		classVars: self squeakObject allClassVarNames;
		javascriptObject: (
			self class classmodelClass convertClassCodeFrom: self).! !

!S2JCompiledClass methodsFor: 'converting' stamp: 'ag 12/14/2010 01:05'!
updateMethodsFrom: aSourceClass
	
	^ aSourceClass methodDict values collect: [ :method | 
		self codeFactory cacheObjectForMethod: method ]! !

S2JCompiledObject subclass: #S2JCompiledDoIt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JCompiledDoIt class methodsFor: 'instance creation' stamp: 'ag 12/22/2010 12:40'!
from: aString
	
	^ self new
		squeakObject: aString;
		yourself! !

!S2JCompiledDoIt methodsFor: 'converting' stamp: 'ag 12/14/2010 00:33'!
hasChanged
	"DoIt-code does not change"
	
	^ false! !

!S2JCompiledDoIt methodsFor: 'converting' stamp: 'ag 12/14/2010 00:31'!
isValid
	"returning false to clear the cache more frequently from DoIt-snippets."
	
	^ false! !

!S2JCompiledDoIt methodsFor: 'converting' stamp: 'ag 12/14/2010 00:32'!
update
	
	self javascriptObject: 
		(self class converterClass 
			convertDoIt: self squeakObject).! !

S2JCompiledObject subclass: #S2JCompiledMethod
	instanceVariableNames: 'javascriptClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JCompiledMethod class methodsFor: 'instance creation' stamp: 'ag 12/22/2010 12:40'!
from: aSqueakClassOrMethod inClass: anS2JCompiledClass
	
	^ self new
		squeakObject: aSqueakClassOrMethod;
		javascriptClass: anS2JCompiledClass;
		yourself! !

!S2JCompiledMethod methodsFor: 'private' stamp: 'ag 12/16/2010 11:38'!
currentSqueakObject
	
	^ self class converterClass
		method: self squeakObject selector
		of: self squeakObject methodClass! !

!S2JCompiledMethod methodsFor: 'converting' stamp: 'ag 12/17/2010 00:15'!
hasChanged
	"This is the main point of cache-validation. The instance-equality of the CompiledMethod is used.
	If the method-code changed, the method is recompiled. If the method is recompiled, there will be a new instance of CompiledMethod."
	
	^ (self squeakObject == self currentSqueakObject) not! !

!S2JCompiledMethod methodsFor: 'converting' stamp: 'ag 12/14/2010 01:38'!
isValid
	
	^ self javascriptClass isValid
	and: [ self squeakObject notNil ]
	and: [ self squeakObject methodClass includesSelector: self squeakObject selector ]! !

!S2JCompiledMethod methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:44'!
javascriptClass
	
	^ javascriptClass! !

!S2JCompiledMethod methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:44'!
javascriptClass: anS2JCompiledClass
	
	javascriptClass := anS2JCompiledClass! !

!S2JCompiledMethod methodsFor: 'converting' stamp: 'ag 12/16/2010 11:43'!
update
	
	self
		squeakObject: self currentSqueakObject;
		javascriptObject: (self class converterClass convertCompiledMethod: self squeakObject).! !

!S2JCompiledObject class methodsFor: 'converting' stamp: 'ag 12/13/2010 23:52'!
classmodelClass
	
	^ S2JFullClassModel! !

!S2JCompiledObject class methodsFor: 'converting' stamp: 'lw 1/4/2011 11:48'!
converterClass
	
	^ S2JPrinter! !

!S2JCompiledObject methodsFor: 'comparing' stamp: 'ag 12/13/2010 22:01'!
= anotherObject
	"Designed to be found in a dictionary by the squeakObject"
	
	^ (anotherObject class = self class
		and: [ anotherObject squeakObject = self squeakObject ])
		or: [ anotherObject = self squeakObject ]! !

!S2JCompiledObject methodsFor: 'converting' stamp: 'ag 12/13/2010 22:41'!
hasChanged
	"Return true, if the source squeak-object has changed, since it has last been updated."
	
	self subclassResponsibility! !

!S2JCompiledObject methodsFor: 'converting' stamp: 'ag 12/13/2010 22:16'!
isValid
	"Check, whether the squeak-object is still valid: the squeak-class/method has not been deleted yet and is still present."
	
	self subclassResponsibility! !

!S2JCompiledObject methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:34'!
javascriptObject
	
	^ javascriptObject! !

!S2JCompiledObject methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:34'!
javascriptObject: anObject
	
	javascriptObject := anObject! !

!S2JCompiledObject methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:34'!
squeakObject
	
	^ squeakObject! !

!S2JCompiledObject methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:34'!
squeakObject: anObject
	
	squeakObject := anObject! !

!S2JCompiledObject methodsFor: 'converting' stamp: 'ag 12/13/2010 22:40'!
update
	"Update converted contents from the current state of the squeak-object."
	
	self subclassResponsibility! !

Object subclass: #S2JShape
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Graphics'!

S2JShape subclass: #S2JCircle
	instanceVariableNames: 'position radius color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Graphics'!

S2JCircle subclass: #S2JBall
	instanceVariableNames: 'speed direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Graphics-Examples'!

!S2JBall methodsFor: 'as yet unclassified' stamp: 'ag 1/3/2011 18:14'!
initialize
	
	super initialize.
	self position: Point new.
	self position setX: 1 setY: 1.! !

!S2JBall methodsFor: 'as yet unclassified' stamp: 'LT 12/21/2010 18:25:39.085'!
step

	self position: self position + (self direction * self speed).
	super step.! !

!S2JCircle class methodsFor: 'as yet unclassified' stamp: 'LT 12/21/2010 18:14:09.365'!
position: aPoint radius: aNumber

	^ self new
		position: aPoint;
		radius: aNumber;
		yourself! !

!S2JCircle class methodsFor: 'as yet unclassified' stamp: 'LT 12/21/2010 18:23:51.328'!
position: aPoint radius: aNumber canvas: aCanvas

	^ self new
		position: aPoint;
		radius: aNumber;
		canvas: aCanvas
		yourself! !

!S2JCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.72'!
color
	^ color! !

!S2JCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.729'!
color: anObject
	color := anObject! !

!S2JCircle methodsFor: 'as yet unclassified' stamp: 'ag 1/3/2011 17:05'!
drawOn: aCanvas
	
	"CTK library: http://canvastoolkit.codeplex.com/"
	aCanvas js setColor: self color asHTMLColor.
	aCanvas js fillCircle: { self position x. self position y. self radius }.! !

!S2JCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.683'!
position
	^ position! !

!S2JCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.695'!
position: anObject
	position := anObject! !

!S2JCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.704'!
radius
	^ radius! !

!S2JCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.712'!
radius: anObject
	radius := anObject! !

!S2JCircle methodsFor: 'as yet unclassified' stamp: 'ag 1/3/2011 17:14'!
step

	self position x: (self position x + 1).
	self drawOn: self canvas.! !

!S2JShape methodsFor: 'accessing' stamp: 'sec 12/22/2010 12:03'!
canvas
	^ canvas! !

!S2JShape methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:33:58.38'!
canvas: anObject
	canvas := anObject! !

S2JShape subclass: #S2JWorld
	instanceVariableNames: 'bounds elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Graphics'!

S2JWorld subclass: #S2JBallGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Graphics-Examples'!

!S2JBallGame commentStamp: 'sec 1/4/2011 10:22' prior: 0!
usage:
S2JCodeFactory clearCache.
S2JBouncingBallsApp startWebApp.!

!S2JBallGame methodsFor: 'as yet unclassified' stamp: 'ag 1/3/2011 18:16'!
initialize
	
	super initialize.
	1 timesRepeat: [ self elements add: (S2JBall position: (0@0) radius: 10 canvas: self canvas )]! !

!S2JWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.324'!
bounds
	^ bounds! !

!S2JWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.336'!
bounds: anObject
	bounds := anObject! !

!S2JWorld methodsFor: 'as yet unclassified' stamp: 'ag 1/3/2011 17:07'!
clear
	
	self canvas js setColor: '#ff0000'.
	self canvas js
		fillRect: {
			self bounds origin x.
			self bounds origin y.
			self bounds corner x.
			self bounds corner y }.! !

!S2JWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.346'!
elements
	^ elements! !

!S2JWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.352'!
elements: anObject
	elements := anObject! !

!S2JWorld methodsFor: 'as yet unclassified' stamp: 'sec 1/5/2011 11:29'!
initialize
	
	" new ctk.Graphics(document.getElementById(""myCanvas"")); "
	self
		elements: OrderedCollection new;
		bounds: Rectangle new;
		canvas: ((JsGlobal js ctk js Graphics) js new: (JsGlobal js document js getElementById: #ballCanvas));
		clear.! !

!S2JWorld methodsFor: 'as yet unclassified' stamp: 'ag 1/3/2011 17:12'!
step

	self clear.
	self elements do: [ :each | each step].! !

Object subclass: #S2JUtils
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JUtils class methodsFor: 'grepping' stamp: 'ag 12/13/2010 21:19'!
grep: aString
	"Search the source-code of our packages and return a collection of all CompiledMethods, that contain aString in their source-code."
	
	| methods packages |
	methods := OrderedCollection new.
	packages := PackageOrganizer default.
	self ourPackages do: [ :packageName | | package |
		package := packages packageNamed: packageName ifAbsent: [ nil ].
		package ifNotNil: [
			package methods do: [ :method |
				(method compiledMethod getSource asString includesSubString: aString)
					ifTrue: [ methods add: method compiledMethod ]]]].
	^ methods! !

!S2JUtils class methodsFor: 'grepping' stamp: 'ag 12/13/2010 13:35'!
ourPackages
	
	^ #( 'Squeak2JS' 'SwazooSpike' )! !

OMeta2 subclass: #S2JOMeta2
	instanceVariableNames: 'currentMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

S2JOMeta2 subclass: #S2JAstReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

S2JAstReader subclass: #S2JAbstractPrinter
	instanceVariableNames: 'indentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JAbstractPrinter class methodsFor: 'converting' stamp: 'lw 1/4/2011 11:20'!
inputConverter
	
	self subclassResponsibility
! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/8/2010 14:44'!
arguments =
	
	translate*:identifiers
	-> [ self functionParameters: identifiers ]! !

!S2JAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 12/16/2010 16:57'!
array = 
	
	translate*:contents
	-> [ '[', (S2JNode concatenate: contents separatedBy: ', '), ']' ]! !

!S2JAbstractPrinter methodsFor: 'helpers' stamp: 'sec 1/4/2011 16:22'!
asJSString: aString
	
	| result |
	result := S2JNode concatenate: (aString findTokens: '"') separatedBy: '\"'.
	result := S2JNode concatenate: (result findTokens: Character cr asString) separatedBy: '\n'.
	^ '"', result, '"'! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/9/2010 16:19'!
assignment =
	
	translate! !

!S2JAbstractPrinter methodsFor: 'accessing' stamp: 'lw 1/4/2011 17:41'!
cSpace

	^ self class space! !

!S2JAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 12/13/2010 19:27'!
character =
	
	// TODO Squeak-characters always applicable in JS ?
	
	char:result
	-> [ self asJSString: result asString ]! !

!S2JAbstractPrinter methodsFor: 'helpers' stamp: 'lw 1/4/2011 17:26'!
concatenate: expressions

	^ S2JNode concatenate: expressions separatedBy: ';', self indentation.! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/8/2010 14:45'!
expression =
	
	translate:expressionBody translate*:assignments
	-> [ self expression: expressionBody withAssignments: assignments ]! !

!S2JAbstractPrinter methodsFor: 'helpers' stamp: 'lw 1/4/2011 17:43'!
expression: anExpressionBodyString withAssignments: aStringCollection
	
	| expressionString |
	expressionString := ''.
	aStringCollection isEmpty
		ifFalse: [ expressionString := expressionString, (S2JNode concatenate: aStringCollection separatedBy: self cSpace, '=', self cSpace), self cSpace, '=', self cSpace ].
	expressionString := expressionString, anExpressionBodyString.
	^ expressionString! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'sec 1/5/2011 12:06'!
functionCall =
	// Can be either an invokation of a named function of on object OR an invokation of a anonymous function
	
	&anything:receiverNode (nil | translate):receiver ^string:functionName translate:arguments
	-> [ self functionCall: functionName to: (
		(receiverNode notNil and: [ receiverNode name = 'functionDeclaration' ])
			ifTrue: [ '(', receiver, ')' ]
			ifFalse: [ receiver ]
		) withArguments: arguments ]! !

!S2JAbstractPrinter methodsFor: 'helpers' stamp: 'sec 1/5/2011 12:03'!
functionCall: aFunctionNameOrDeclaration to: aReceiverString withArguments: anArgumentsString

	| function |
	function := (aFunctionNameOrDeclaration name = 'functionDeclaration') 
		ifTrue: ['(', aFunctionNameOrDeclaration, ')'] 
		ifFalse: [aFunctionNameOrDeclaration].
	
	^ (aReceiverString
		ifNotNil: [ aReceiverString, '.' ]
		ifNil: [ '' ]), function, anArgumentsString! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 1/4/2011 16:37'!
functionContent =
	// This is intentionally not named 'statements', to deny all nested statements-nodes
	// The ast-to-ast step must flatten all statements into one list of expressions here
	
	translate*:expressions
	-> [ self concatenate: expressions ]! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 1/4/2011 16:59'!
functionDeclaration =
	
	[ self indent ]
	translate:arguments
	translate:statements
	[ self unindent ]
	-> [ self functionDeclaration: arguments withBody: statements ]! !

!S2JAbstractPrinter methodsFor: 'helpers' stamp: 'LT 1/4/2011 18:38:44.339'!
functionDeclaration: aParameterString withBody: aStatementsString
	"aParameterString already contains the parantheses; #functionParameters: should be used."
	
	| functionBody |
	functionBody := ''.
	aStatementsString ifNotNil: [ functionBody := functionBody, aStatementsString].
	functionBody ifNotEmpty: [ functionBody := functionBody, ';' ].
	^ 'function', aParameterString, '{', self indentation, self class indentation, functionBody, '}'! !

!S2JAbstractPrinter methodsFor: 'helpers' stamp: 'ag 12/9/2010 16:05'!
functionParameters: aStringCollection
	
	^ '(', (S2JNode concatenate: aStringCollection separatedBy: ', '), ')'! !

!S2JAbstractPrinter methodsFor: 'helpers' stamp: 'sec 1/4/2011 11:46'!
hasSelector: aSymbol
	"Adding the superclass method dictionary to the searcharea for matching methods is required because the printers don't implement all the methods on their own"
	
	^ ((super hasSelector: aSymbol) or: [ self class superclass includesSelector: aSymbol ])
		ifTrue: [ true ]
		ifFalse: [ self error: 'Unknown selector: ', aSymbol asString. false ]! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 14:14'!
header =
	
	^string:functionName arguments:arguments
	-> [ functionName -> arguments ]! !

!S2JAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 12/2/2010 11:52'!
identifier =
	
	^string:identifier
	-> [ identifier ]! !

!S2JAbstractPrinter methodsFor: 'accessing' stamp: 'lw 1/4/2011 17:38'!
indent
	
	self indentation: self indentation, self class indentation! !

!S2JAbstractPrinter methodsFor: 'accessing' stamp: 'lw 1/4/2011 17:25'!
indentation
	^ indentation! !

!S2JAbstractPrinter methodsFor: 'accessing' stamp: 'lw 1/4/2011 17:25'!
indentation: anObject
	indentation := anObject! !

!S2JAbstractPrinter methodsFor: 'initialization' stamp: 'lw 1/4/2011 17:25'!
initialize

	super initialize.
	self indentation: ''.! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 19:37'!
method =
	// This does not return a string, but an association from the method-name to the method-declaration
	
	translate:functionNameAndArguments
	translate:statements
	-> [ functionNameAndArguments key -> 
		(self
			functionDeclaration: functionNameAndArguments value
			withBody: statements) ]! !

!S2JAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 12/16/2010 16:32'!
number =
	
	^number:number
	-> [ number asString ]! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 20:15'!
paranthesizedExpression =
	
	expression:value
	-> [ '(', value, ')' ]! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 17:50'!
primitiveDeclaration =
	
	// TODO not implemented yet!!
	
	anything // actual value ignored for now
	functionCall(nil. 'primitiveCall'. self node: 'arguments'):result
	-> [ result ]! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 17:37'!
reservedWord =
	
	^string! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 18:55'!
returnExpression =
	
	expression:value
	-> [ 'return ', value ]! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/22/2010 16:36'!
slotAccess =
	
	(nil | translate):object ^symbol:slotName
	-> [ (object ifNotNil: [ object, '.' ] ifNil: [ '' ]), slotName asString ]! !

!S2JAbstractPrinter methodsFor: 'temp' stamp: 'ag 1/3/2011 17:43'!
statements =
	
	functionContent! !

!S2JAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 12/2/2010 11:34'!
string =
	
	^string:string
	-> [ self asJSString: string ]! !

!S2JAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 12/13/2010 21:41'!
symbol =
	// Symbols are translated to JS-strings
	
	^symbol:s
	-> [ self asJSString: s asString ]! !

!S2JAbstractPrinter methodsFor: 'accessing' stamp: 'lw 1/4/2011 17:38'!
unindent
	
	self indentation: (self indentation allButLast: self class indentation size)! !

!S2JAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 19:40'!
variableDeclaration =
	
	translateNamed('identifier')+:variableNames translateNamed('assignment')?:assignment
	-> [ self variableDeclaration: variableNames withAssignment: assignment ]! !

!S2JAbstractPrinter methodsFor: 'helpers' stamp: 'lw 1/4/2011 17:42'!
variableDeclaration: variableNames withAssignment: assignment
	"Acts as an expression, not terminated by a semi colon"
	
	| result |
	variableNames size = 1
		ifTrue: [
			result := 'var ', variableNames first.
			assignment ifNotNil: [
				result := result, self cSpace, '=', self cSpace, assignment]]
		ifFalse: [
			result := 'var ', (S2JNode concatenate: variableNames separatedBy: ';var ').
			assignment ifNotNil: 
				[ result := result, (S2JNode concatenate: variableNames separatedBy: self cSpace, '=', self cSpace), self cSpace, '=', self cSpace, assignment ]].
	^ result! !

S2JAbstractPrinter subclass: #S2JPrettyPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JPrettyPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
indentation

	^ '    '! !

!S2JPrettyPrinter class methodsFor: 'converting' stamp: 'lw 1/4/2011 17:30'!
inputConverter

	^ S2JSqueakAstToJsAst! !

!S2JPrettyPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
space

	^ ' '! !

!S2JPrettyPrinter methodsFor: 'initialization' stamp: 'lw 1/4/2011 17:30'!
initialize

	super initialize.
	self indentation: String cr.! !

S2JAbstractPrinter subclass: #S2JPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
indentation

	^ ''! !

!S2JPrinter class methodsFor: 'converting' stamp: 'lw 1/4/2011 11:22'!
inputConverter

	^ S2JSqueakAstToJsAst! !

!S2JPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:30'!
space

	^ ''! !

!S2JAstReader class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:20'!
applyRule: aRule on: aMatcher
	
	^ super applyRule: #translate on: aMatcher! !

!S2JAstReader class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:13'!
createInputFrom: aString as: aRule insideMethod: aCompiledMethod
	
	^ { self inputConverter convert: aString as: aRule insideMethod: aCompiledMethod }! !

!S2JAstReader class methodsFor: 'converting private' stamp: 'ag 12/8/2010 22:13'!
inputConverter
	"An AstReader should know, which converter-class can provide the ast wants to read"
	
	self subclassResponsibility! !

!S2JAstReader methodsFor: 'helpers' stamp: 'ag 12/16/2010 23:37'!
hasSelector: aSymbol
	"Offers a hook to catch, if an unknown node occurs"
	
	^ self class includesSelector: aSymbol! !

!S2JAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:36'!
translate =
	// Translate the next node using it's name as rule
	
	translateNamed(nil)! !

!S2JAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:36'!
translateNamed :nodeName =
	// Assert, that the next node has the name nodeName and translate it using it's name as rule
	
	translateNamedWith(nodeName. nodeName)! !

!S2JAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:36'!
translateNamedWith :nodeName :targetRule =
	// Assert, that the next node has the name nodeName and translate it with targetRule
	
	translateNamedWithArgument(nodeName. targetRule. nil)! !

!S2JAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:35'!
translateNamedWithArgument :nodeName :targetRule :argument =
	// Assert, that the next node has the name nodeName, use targetRule to convert the node and pass argument when calling targetRule
	
	// Lookahead for one node
	&anything:node
	
	// Some assertions, e.g. about the nodeName
	?[ node class = S2JNode ]
	?[ nodeName isNil | (node name = nodeName )]
	[ targetRule ifNil: [ node name asSymbol ] ifNotNil: [ targetRule asSymbol ]]:appliedRule
	?[ self hasSelector: appliedRule ]
	
	// If an argument is given, call the targetRule with that argument. Else, call the targetRule without arguments
	(( ?[ argument notNil ] { apply(appliedRule. argument):result } )
	| { apply(appliedRule):result })
	
	// Return the parsed content of the node
	-> [ result ]! !

!S2JAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:34'!
translateWith :aRule =
	// Translate the next node with aRule, regardless of it's name
	
	translateNamedWith(nil. aRule)! !

!S2JAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:47'!
translateWithArgument :aRule :argument =
	// Translate the next node with aRule, regardless of it's name, and pass aRule the argument
	
	translateNamedWithArgument(nil. aRule. argument)! !

S2JAstReader subclass: #S2JAstToAst
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JAstToAst methodsFor: 'helpers' stamp: 'ag 12/22/2010 13:45'!
passThroughAndTranslate =
	
	// TODO add all primitive values?..
	
	^symbol // use the primitive symbol rule, not the rule defined in this class
|	string
|	number
|	char
|	nil
	
|	({ translate*:children }:node
	-> [ self node: node name with: children ])! !

!S2JAstToAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:37'!
renameTo :nodeName =
	
	translate*:contents
	-> [ self node: nodeName with: contents ]! !

!S2JAstToAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:31'!
translate = 
	
	^translate
|	passThroughAndTranslate! !

S2JAstToAst subclass: #S2JJsAstOptimizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JJsAstOptimizer class methodsFor: 'converting' stamp: 'ag 12/8/2010 21:30'!
inputConverter
	
	self error: 'The Js-Ast-Optimizer is not yet functional!!'.
	^ S2JSqueakToJsAst! !

!S2JJsAstOptimizer methodsFor: 'convert special cases' stamp: 'ag 12/8/2010 10:38'!
forLoop =
	// Special case of keywordExpression
	

	translate:receiver symbol:selector translate*:arguments
	?[ selector = #do: ]
	?[ arguments size = 1 ]
	[ arguments first ]:block
	?[ block size >= 1 ]
	?[ block first name = 'arguments' ]
	?[ block first size = 1 ]
	-> [ self forLoopOver: receiver do: block ]! !

!S2JJsAstOptimizer methodsFor: 'convert special cases' stamp: 'ag 12/8/2010 11:03'!
forLoopOver: anArrayNode do: aBlockNode

	| arrayName statements aStatementsNode aTemporariesNode loopVariableName |
	arrayName := 'arr$'.
	loopVariableName := aBlockNode first first.
	aStatementsNode := aBlockNode detect: [:each | each name = 'statements'] ifNone: [ nil ].
	aTemporariesNode := aBlockNode detect: [:each | each name = 'temporaries'] ifNone: [ nil ].
	aStatementsNode ifNotNil: [ statements := self apply: #translate withArgs: aStatementsNode].
	^self node: 'statements' with:
		{self node: 'variableDeclaration' with:
			{self node: 'identifier' with: { arrayName }.
			  self node: 'expression' with: anArrayNode}.
		 self node: 'forLoop' withoutNils:
			{self node: 'identifier' with: { arrayName }.
			loopVariableName.
			aTemporariesNode.
			statements}}! !

!S2JJsAstOptimizer methodsFor: 'convert complex' stamp: 'ag 12/8/2010 13:54'!
keywordExpression = 
	
	forLoop
|	messageSendExpression // ...not correct ...
! !

S2JAstToAst subclass: #S2JSqueakAstToJsAst
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JSqueakAstToJsAst class methodsFor: 'mapping' stamp: 'ag 1/5/2011 09:51'!
cascadeReceiverVariableName
	
	^ 'cascadeReceiver', self escapeCharForIdentifier! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping' stamp: 'robi 1/4/2011 15:21'!
escapeCharForIdentifier
	
	^ '$'! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping' stamp: 'robi 1/4/2011 15:21'!
escapeCharForMethod
	
	^ '_'! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping' stamp: 'sec 1/5/2011 11:54'!
escapeReservedWord: aStringOrSymbol
	
	aStringOrSymbol ifNil: [ ^nil ].
	^ ((self jsReservedWords includes: aStringOrSymbol asString)
		ifTrue: [ self escapeCharForMethod ]
		ifFalse: [ '' ]), aStringOrSymbol asString! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping' stamp: 'ag 12/22/2010 15:16'!
functionCallFor: aSelector of: aReceiver
	"Return association from receiver to function-name. If aReceiver is an identifier, it has already been parsed!!"
	
	| result |
	result := self globalMethodFor: aSelector sentTo: aReceiver.
	result ifNil: [
		result := self jsFunctionNameFor: aSelector].
	^ result! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-globals' stamp: 'ag 12/22/2010 14:30'!
globalFunctionReceivers
	
	^ Dictionary newFrom: {
		JsGlobal name -> nil.
		JsDocument name -> 'document'
	}! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-globals' stamp: 'ag 12/22/2010 14:59'!
globalMethodFor: aMethodName sentTo: aReceiver
	"Return the name of the special global js-function, that will be called, when aMethodName is sent to aReceiver.
	Return nil, if nothing could be matched."
	
	| receiver functionName |
	receiver := aReceiver ifNotNil: [ aReceiver first ] ifNil: [ nil ].
	functionName := self globalMethodNames at: receiver ifAbsent: [ nil ].
	functionName ifNotNil: [ functionName := functionName at: aMethodName ifAbsent: [ nil ] ].
	^ functionName
		ifNotNil: [ functionName ]
		ifNil: [ nil ]! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-globals' stamp: 'ag 12/22/2010 15:00'!
globalMethodNames
	"The nil-key represents JsGlobal"
	
	^ Dictionary newFrom: {
		nil ->  ( Dictionary newFrom: {
			'alert:' -> 'alert'
			}).
		JsDocument name ->  ( Dictionary newFrom: {
			'getElementById:' -> 'getElementById'
			})
		}! !

!S2JSqueakAstToJsAst class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:14'!
inputConverter
	
	^ S2JParser! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 1/5/2011 09:43'!
jsFunctionNameFor: aStringOrSymbol
	
	| result |
	result := ''.
	aStringOrSymbol asString do: [ :each | | jsIdentifier |
		jsIdentifier := self squeakCharacterToJsIdentifier at: each ifAbsent: [each asString].
		result := result, jsIdentifier].
	^ self escapeReservedWord: result! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 1/5/2011 10:08'!
jsIdentifierFor: aString inMethod: aCompiledMethod
	"Check, if the identifier is a special global variable (JsGlobal, document, etc.) and escape reserved js-words"
	
	^ self globalFunctionReceivers
		at: aString
		ifAbsent: [ | identifierName |
			identifierName := self escapeReservedWord: aString.
			(aCompiledMethod notNil and: [ aCompiledMethod methodClass allInstVarNames includes: aString ])
				ifTrue: [
					S2JNode named: 'slotAccess' with: { S2JNode named: 'reservedWord' with: { 'this' }. identifierName asSymbol } ]
				ifFalse: [
					S2JNode named: 'identifier' with: { identifierName } ]]! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 1/5/2011 09:58'!
jsKeywordFor: aString
	"Uncovered keywords: thisContext, homeContext, super"
	
	"TODO cannot translate some of the keywords below!!... just stubs!!"
	
	^ aString
		caseOf: {
			[ 'self' ] -> [ 'this' ].
			[ 'true' ] -> [ self escapeReservedWord: 'true' ].
			[ 'false' ] -> [ self escapeReservedWord: 'false' ].
			[ 'nil' ] -> [ 'null' ].
			[ 'super' ] -> [ 'SUPER' ].
			[ 'superContext' ] -> [ 'SUPER_CONTEXT' ].
			[ 'thisContext' ] -> [ 'THIS_CONTEXT' ].
		}
		otherwise: [ self error: 'Cannot translate keyword to JS: ', aString ]! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 1/5/2011 09:36'!
jsReservedWords
	"http://javascript.about.com/library/blreserved.htm"
	
	^ #('abstract' 'as' 'boolean' 'break' 'byte' 'case' 'catch' 'char' 'class' 'continue' 'const' 'debugger' 'default' 'delete' 'do' 'double' 'else' 'enum' 'export' 'extends' 'false' 'final' 'finally' 'float' 'for' 'function' 'goto' 'if' 'implements' 'import' 'in' 'instanceof' 'int' 'interface' 'is' 'long' 'namespace' 'native' 'new' 'null' 'package' 'private' 'protected' 'public' 'return' 'short' 'static' 'super' 'switch' 'synchronized' 'this' 'throw' 'throws' 'transient' 'true' 'try' 'typeof' 'use' 'var' 'void' 'volatile' 'while' 'with'
	
	"Classes, that already exist in javascript, should not be overridden, our squeak-version of these classes will be escaped."
	'Object' 'Function'
	)! !

!S2JSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'robi 1/4/2011 15:24'!
squeakCharacterToJsIdentifier
	"Several characters can be used for selectors in squeak but
	are not allowed for JavaScript functionname"
	
	^ (Dictionary newFrom:
		{$: -> ''.  
		$+ -> 'plus'.
		$- -> 'minus'.
		$* -> 'times'.
		$/ ->  'slash'.
		$\ -> 'backslash'.
		$~ -> 'tilde'.
		$< ->  'less'.
		$> -> 'greater'.
		$= -> 'equals'.
		$@ -> 'at'.
		$% -> 'percent'.
		$& -> 'and'.
		$? -> 'question'.
		$!! -> 'exclamation'.
		$` -> 'backtick'.
		$, -> 'comma'. 
		$| -> 'pipe'})
			collect: [ :string | self escapeCharForMethod, string ]! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'sec 1/5/2011 10:02'!
addReturnExpression: statements
	
	(statements isEmpty or: [(statements last name = 'returnExpression') not])
		ifTrue: [
			statements add: (self node: 'returnExpression' with: { self node: 'reservedWord' with: { 'this'} })].! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 13:07'!
arguments =
	
	renameTo('arguments')! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/8/2010 12:56'!
array =
	// Pack inner nodes in expression-nodes
	
	translate*:elements
	-> [ self node: 'array' with: (elements collect: [ :each | self node: 'expression' with: { each } ])]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 1/3/2011 14:18'!
binaryExpression =
	
	messageSendExpression! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'sec 1/4/2011 21:30'!
block =
	
	translateNamed('arguments')?:arguments
	methodContent:statements
	
	// All return-statements in the block are nonlocal returns. After that, the last expression into a return-expression like in a method.
	// Nonlocal returns are function calls in JS: nonLocalReturn()
	renameNonLocalReturns(statements)
	renameLastExpression(statements)
	
	-> [self node: 'functionCall' with: 
		{nil.
		'block'.
		self node: 'arguments' with: 
			{self node: 'functionDeclaration' withoutNils: 
				{( arguments ifNotNil: [ arguments ] ifNil: [ self node: 'arguments' ] ).
				statements }}}]
		! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 12:38'!
braceExpression =
	
	renameTo('array')! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/16/2010 23:39'!
byteArray =
	
	array! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 1/5/2011 09:47'!
cascadeReceiver
	
	^ self node: 'identifier' with: { self class cascadeReceiverVariableName }! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/16/2010 23:47'!
cascadedExpression =
	
	translate:receiver
	translateWithArgument(#messageSendExpression. self cascadeReceiver)*:functions
	-> [ self cascadedExpression: functions to: receiver ]! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'srv 1/5/2011 11:44'!
cascadedExpression: functions to: receiver
	"The statements-node created here is later flattened into one flat list of expressions."
	
	| statements |
	statements := self node: 'functionDeclaration' with:
		{ self node: 'arguments'. self node: 'functionContent' with: { 
			self node: 'variableDeclaration' with: { self cascadeReceiver. 
				self node: 'assignment' with: { receiver }
				} } }.
	functions do: [ :each | statements last add: (self node: 'expression' with: { each })].
	statements last last name: 'returnExpression'.
	^ self
		functionCall: 'apply'
		to: statements
		withArguments: { self node: 'reservedWord' with: { 'this' } }! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 1/3/2011 16:53'!
checkSingleArgumentSelector: aSymbol
	"Answer, whether aSymbol is a selector for a keyword-message with one argument.
	aSymbol is already is keyword-selector.
	TODO Please implement a better way to do this."
	
	| tokens |
	tokens := aSymbol findTokens: $:.
	^ tokens size = 1 and: [ tokens first = (aSymbol asString subStrings: ':') first ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/16/2010 23:12'!
doItSnippet =
	// No need to turn the last expression into a returnExpression, like in a method
	
	methodContent! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 12/22/2010 15:13'!
functionCall: selector to: receiver withArguments: arguments
	
	| functionName |
	functionName := self class functionCallFor: selector of: receiver.
	^ self node: 'functionCall' with: {
			receiver.
			functionName.
			self node: 'arguments' with: arguments }! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/22/2010 16:37'!
identifier =
	
	string:name
	-> [ self class jsIdentifierFor: name inMethod: self currentMethod ]! !

!S2JSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'ag 1/3/2011 15:50'!
jsSpecialMessage =
	// reads one unary message with the selector #js. Returns the receiver.
	
	translate:receiver
	^symbol:selector
	?[ selector = 'js' asSymbol ]
	-> [ receiver ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 1/3/2011 14:23'!
keywordExpression = 
	
	slotMethodCall
|	messageSendExpression! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/22/2010 14:47'!
messagePattern =
	
	^symbol:selector translate*:arguments
	-> [ self node: 'header' with: { self class jsFunctionNameFor: selector }, arguments ]! !

!S2JSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:25'!
messageSendExpression =
	
	translate:receiver ^symbol:selector translate*:arguments
	-> [ self functionCall: selector to: receiver withArguments: arguments ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'sec 1/5/2011 10:03'!
method =
	
	translateWith(#messagePattern):header
	methodContent:statements
	[ self addReturnExpression: statements ]
	
	-> [ self node: 'method' with: { header. statements }]! !

!S2JSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'srv 1/5/2011 11:48'!
methodContent  =
	// This can also be used in a place, where primitive-declarations are not allowed: the parser already handles that correctly
	// This flattens all expressions (cascaded expressions in the first place) into one flat collection of expressions
	
	translateNamed('temporaries')?:temporaries
	translateNamed('primitiveDeclaration')*:primitives
	translate?:statements
	-> [ self statements: statements withTemps: temporaries andPrimitives: primitives ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'LT 12/22/2010 17:01:34.085'!
number =
	// Number-literals are packed into a 'primitive' number-function-call
	
	^number:number
	-> [ self functionCall: #Number to: nil withArguments: { self node: 'number' with: { number } } ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/16/2010 23:48'!
paranthesizedExpression =
	
	! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/13/2010 19:17'!
primitiveDeclaration =
	
	renameTo('primitiveDeclaration')! !

!S2JSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'sec 1/4/2011 22:09'!
renameLastExpression :statements =

	[ statements ifNotEmpty: [ 
		(statements last name = 'functionCall'
			and: [statements last second = 'nonLocalReturn'])
		 		ifFalse: [ statements last name: 'returnExpression' ] ] ]! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 1/5/2011 10:00'!
renameNonLocalReturns :statements =
	
	[ statements doWithIndex: [:st :index | st name = 'returnExpression' 
		ifTrue: [ statements at: index put: (self functionCall: 'nonLocalReturn' to: nil withArguments: st) ]]]! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/22/2010 14:48'!
reservedWord =
	
	^string:keyword
	-> [ self node: 'reservedWord' with: { self class jsKeywordFor: keyword } ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'ag 1/3/2011 15:49'!
slotAccess =
	// An exception for a unaryMessage.
	// If the receiver of this message is a unary message with the selector #js
	// this is translated to a js-slot-access.
	
	translateWith('jsSpecialMessage'):receiver
	^symbol:selector
	-> [ self node: 'slotAccess' with: { receiver. selector } ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'ag 1/3/2011 16:55'!
slotMethodCall =
	// An exception for a keywordMessage.
	// If the receiver of this message is a unary message with the selector #js
	// AND the single argument of this message is an array-literal,
	// this is translated to a method-call.
	
	translateWith('jsSpecialMessage'):receiver
	^symbol:selector
	?[ self checkSingleArgumentSelector: selector ]
	
	(translateNamed('braceExpression'):arguments
		-> [
			self
				slotMethodCall: selector
				to: receiver
				withArguments: arguments ]
	| translate:singleArgument
		-> [ 
			self
				slotMethodCall: selector
				to: receiver
				withArguments: ( { singleArgument } asOrderedCollection )
			]
	)! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 1/3/2011 16:49'!
slotMethodCall: selector to: receiver withArguments: arguments
	
	^ self
		functionCall: ((selector subStrings: ':') first asString)
		to: receiver
		withArguments: arguments! !

!S2JSqueakAstToJsAst methodsFor: 'helpers' stamp: 'srv 1/5/2011 11:48'!
statements: aNode withTemps: anElement andPrimitives: anElementCollection
	
	| result |
	result := aNode ifNil: [ self node: 'statements' ] ifNotNil: [ aNode ].
	anElement ifNotNil: [ result addFirst: anElement; yourself ].
	anElementCollection ifNotNil: [ result addAllFirst: anElementCollection; yourself ].
	^ result name: 'functionContent'; yourself! !

!S2JSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/22/2010 13:45'!
symbol =
	
	renameTo('symbol')! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/16/2010 12:31'!
temporaries =
	
	renameTo('variableDeclaration'):temporaries
	[ temporaries ifEmpty: [ nil ] ifNotEmpty: [ temporaries ] ]! !

!S2JSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 1/3/2011 14:23'!
unaryExpression =
	
	slotAccess
|	messageSendExpression! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:01'!
allMethodsDo: aBlock
	"Execute aBlock with each parsable method in the image and return the sum of visited methods and classes."
	
	| numberOfObjects |
	numberOfObjects := 0.
	Smalltalk allClasses do: [ :eachClass |
		(self isClassParsableAndNotEmpty: eachClass)  ifTrue: [
			numberOfObjects := numberOfObjects + 1.
			eachClass methodDict do: [ :eachMethod |
				numberOfObjects := numberOfObjects + 1.
				aBlock value: eachMethod ]]].
	^ numberOfObjects! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/15/2010 16:25'!
allMethodsDoAndReport: aBlock
	"Execute aBlock for each method in the image, print which methods have failed
	and notify each 500 methods. Print status-report at the end."
	
	| converted succeeded total |
	converted := -1.
	succeeded := 0.
	total := Smalltalk allClasses inject: 0 into: [ :sum :each | sum + each methodDict size].
	Transcript cr; show: 'Total methods in image: ', total asString.
	[
		self allMethodsDo: 
			[ :eachMethod |
				[ converted := converted + 1. aBlock value: eachMethod. succeeded := succeeded + 1.
				(converted \\ 500 = 0) ifTrue: [ Transcript cr; show: 'Converted ', converted asString, ' methods.' ]
				]
					on: Exception do: [ :err | Transcript cr; show: '	', converted asString, ': ', eachMethod name, ' (', err, ')' ]].
	]
		ensure: [ Transcript cr; show: 'Finished!! ', succeeded asString, ' of ', converted asString, ' operations succeeded!!' ].! !

!S2JOMeta2 class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:20'!
applyRule: aRule on: aMatcher
	
	^ aMatcher apply: aRule! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:05'!
cachableObjects
	
	^ self allMethodsDo: [ :m ]! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/13/2010 14:34'!
classNamed: aClassOrClassname
	
	^ Smalltalk classNamed: aClassOrClassname asString! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/22/2010 16:06'!
convert: aString as: aRule
	
	^ self convert: aString as: aRule insideMethod: nil! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/22/2010 16:06'!
convert: aString as: aRule insideMethod: aCompiledMethod
	
	| matcherToResult |
	matcherToResult := self convertWithoutEnd: aString as: aRule insideMethod: aCompiledMethod.
	self finalizeMatcher: matcherToResult key.
	matcherToResult key apply: #end.
	^ matcherToResult value! !

!S2JOMeta2 class methodsFor: 'tests' stamp: 'ag 12/15/2010 16:26'!
convertAllMethods
	"Convert all methods in this image."
	
	self allMethodsDoAndReport: [ :eachMethod | 
		self convertCompiledMethod: eachMethod].! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/13/2010 17:54'!
convertAllMethodsOf: aClass
	
	^ (self isClassParsableAndNotEmpty: aClass)
		ifTrue: [ | methods |
			methods := Dictionary new.
			aClass methodDict valuesDo:
				[ :method | | result |
					[ result := self convertCompiledMethod: method ]
						on: Exception do: [ :err | self error: 'Failed to convert ', method printString, ': ', err ].
					methods at: result key put: result value].
			methods]
		ifFalse: [ self error: 'Cannot convert class ', aClass name ]! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/22/2010 16:34'!
convertCompiledMethod: aCompiledMethod
	"Before converting aCompiledMethod, check whether we can actually parse it."
	
	(self isMethodParsable: aCompiledMethod)
		ifFalse: [ self error: 'Cannot parse method, invalid compiler-class: ', aCompiledMethod printString ].
	^ self convert: (self sourceOf: aCompiledMethod) as: #method insideMethod: aCompiledMethod! !

!S2JOMeta2 class methodsFor: 'converting debug' stamp: 'ag 12/22/2010 16:02'!
convertDebug: aString as: aRule
	
	| matcherToResult |
	matcherToResult := self matchStringWithoutEnd: aString with: aRule.
	[ matcherToResult key apply: #end ]
		on: OM2Fail do: [ :err | 
			matcherToResult value explore. 
			self error: err ].
	^ matcherToResult value! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/13/2010 16:06'!
convertDoIt: aString
	
	^ self convert: aString as: #doItSnippet! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:19'!
convertMethod: aString
	
	^ self convert: aString as: #method! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:20'!
convertMethod: aStringOrSymbol of: aClassOrClassname
	
	| method |
	method := self method: aStringOrSymbol of: aClassOrClassname.
	^ method
		ifNotNil: [ self convertCompiledMethod: method ]
		ifNil: [ self error: 'Method ', aStringOrSymbol asString, ' not found in class ', aClassOrClassname asString ]! !

!S2JOMeta2 class methodsFor: 'tests' stamp: 'ag 12/13/2010 08:44'!
convertRandomMethods: aNumber
	"Match some random methods from the image. Return a String summarizing the result.
	Failed methods are printed to the Transcript."
	
	| runs successes |
	runs := successes := 0.
	aNumber timesRepeat: 
		[ | method |
			method := self randomMethod.
			method ifNotNil: [
				[ runs := runs + 1. S2JParser convertCompiledMethod: method. successes := successes + 1 ]
					on: Error do: [ :err | Transcript cr; cr; show: 'Failed to parse: ', method name, '. ', err ]]].
	^ runs asString, ' runs, ', successes asString, ' successes'! !

!S2JOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:08'!
convertStatements: aString
	
	^ self convert: aString as: #statements! !

!S2JOMeta2 class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:18'!
convertWithoutEnd: aString as: aRule insideMethod: aCompiledMethod
	"Returns both the matcher and the result as an association."
	
	| matcher result |
	matcher := self matcherOn: (self createInputFrom: aString as: aRule insideMethod: aCompiledMethod) readStream.
	matcher
		currentMethod: aCompiledMethod;
		apply: #empty.
	result := self applyRule: aRule on: matcher.
	matcher apply: #spaces.
	^ matcher -> result! !

!S2JOMeta2 class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:12'!
createInputFrom: aString as: aRule insideMethod: aCompiledMethod
	
	self subclassResponsibility! !

!S2JOMeta2 class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:04'!
finalizeMatcher: anOMeta2
	"Do nothing, overwrite if needed to apply anything before applying #end"! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 21:42'!
isClassParsable: aClass
	
	^ aClass compilerClass = Compiler! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 21:44'!
isClassParsableAndNotEmpty: aClass
	
	^ (self isClassParsable: aClass) and: [ aClass methodDict notEmpty ]! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 21:42'!
isMethodParsable: aCompiledMethod
	
	^ self isClassParsable: aCompiledMethod methodClass! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/13/2010 14:34'!
method: aStringOrSymbol of: aClassOrClassname
	
	^ (self classNamed: aClassOrClassname)
		lookupSelector: aStringOrSymbol asSymbol! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/13/2010 13:21'!
randomMethod
	"Methods, that don't work, e.g. because they are too long, are excluded."
	
	| class result |
	result := nil.
	[ result isNil ] whileTrue: [
		class := Smalltalk allClasses atRandom.
		(self isClassParsableAndNotEmpty: class)
			ifTrue: [ result := class methodDict atRandom ]].
	^ result! !

!S2JOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 18:18'!
sourceOf: aCompiledMethod
	
	^ aCompiledMethod getSource asString! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/8/2010 22:53'!
H =
	
	[ self halt ]! !

!S2JOMeta2 methodsFor: 'accessors' stamp: 'ag 12/22/2010 15:48'!
currentMethod
	
	^ currentMethod! !

!S2JOMeta2 methodsFor: 'accessors' stamp: 'ag 12/22/2010 15:48'!
currentMethod: aCompiledMethod
	
	currentMethod := aCompiledMethod! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/8/2010 14:35'!
fail =
	
	?[ false ]! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/13/2010 12:48'!
nil =
	
	anything:object ?[ object isNil ]
	-> [ object ]! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:16'!
node: aString
	
	^ self node: aString with: {}! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/7/2010 22:56'!
node: aString with: anOrderedCollection
	
	^ S2JNode named: aString with: anOrderedCollection! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/7/2010 22:56'!
node: aString withoutNils: anOrderedCollection
	
	^ S2JNode named: aString withoutNils: anOrderedCollection! !

!S2JOMeta2 methodsFor: 'helpers' stamp: 'ag 12/7/2010 22:56'!
node: aString withoutNilsNotEmpty: anOrderedCollection
	
	^ S2JNode named: aString withoutNilsNotEmpty: anOrderedCollection! !

S2JOMeta2 subclass: #S2JParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JParser commentStamp: 'ag 12/7/2010 23:09' prior: 0!
tokens
	Rules, that read one single element in squeal source-code. They all don't return an S2JNode, all are parsed to the
	according Squeak-object (e.g. Number, Symbol, String).
	Spaces before and after the tokens in the source-code are NOT read!!
	This is because in some cases, tokens must be read exactly, without emitting any spaces.
	The things returned from here must not be converted anymore, especially the <> operator is unnecessary.
	
complex elements
	Bigger parts of squeak source-code. Most return an S2JNode (using #node:with:), which contains further complex elements or object read
	by rules in the tokens-protocol. As convention, the nodes (except for helper-rules like primary and messagePattern) should be named like the rules.
	Each rule is supposed to read spaces before applying itself!! This way, rules from this protocol can be called serially, without
	reading spaces inbetween. However, spaces must be read between single tokens.
	
helpers
	Squeak-methods, that are called from within ometa-rules (or helper-rules).
	OMeta2 return-parts of the rules (righthand of ->) cannot contain multiple expressions (?)...
!

!S2JParser class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:13'!
createInputFrom: aString as: aRule insideMethod: aCompiledMethod
	
	^ aString! !

!S2JParser class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:07'!
finalizeMatcher: anOMeta2
	
	anOMeta2 apply: #spaces.! !

!S2JParser class methodsFor: 'parsing' stamp: 'ag 12/1/2010 11:04'!
parseNumber: aString
	"Parse aString to an instance of Number. Return nil, if parsing failed.
	Return nil also, if a number could be read, but not the whole String was processed.
	(Number readFrom: aString does not fail in that case)."
	
	| stream result |
	stream := ReadStream on: aString.
	result := Number readFrom: stream ifFail: [ nil ].
	stream atEnd ifFalse: [ result := nil ].
	^ result! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/9/2010 13:45'!
array =
	
	$(
		(
			(spaces
				(((($# spaces)? array:array) -> [ array ])
				| nodeNamed(#symbolBaseForArray. 'symbol')
				| literalTokenBase
				):element
			) -> [ element ]
		)*:contents
	ch($))
	-> [ self node: 'array' with: contents ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:10'!
binaryExpression =
	
	(binaryExpression | unaryExpression | primary):receiver
	spaces:comment binaryExpressionMessage:message
	-> [ self node: 'binaryExpression' withoutNils:
		{ self extractCommentOf: comment. receiver }, message ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:09'!
binaryExpressionMessage =
	// Not returning a node, but a simple collection
	
	binarySelector:selector
	(unaryExpression | primary):argument
	-> [ { selector. argument } ]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/1/2010 13:32'!
binarySelector =
	
	<$| | ((specialCharacter | $-) specialCharacter*)>:selector
	-> [ selector asSymbol ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/8/2010 22:00'!
block =
	
	ch($[):comment1
		( (ch($:) spaces identifier:argumentName -> [ argumentName ])+:arguments ch($|)?:argumentSeparator )?
		temporaries?:temporaries
		statements?:statements
	ch($]):comment2
	
	// Forbidden (and not covered above): Arguments without separator bar, but with statements or temporaries
	?[ argumentSeparator notNil | arguments isNil | ((temporaries isNil or: [temporaries isEmpty]) & (statements isNil or: [statements isEmpty])) ]
	
	-> [ self node: 'block' withoutNils: { self extractCommentOf: comment1.
			self node: 'arguments' withoutNilsNotEmpty: arguments.
			temporaries. statements.
			self extractCommentOf: comment2} ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 21:32'!
braceExpression =
	
	ch(${):comment1
		(expression:expr ch($.) -> [ expr ] )*:expressions
		expression?:lastExpression
	ch($}):comment2
	
	-> [ self braceExpressionWith: expressions and: lastExpression ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/13/2010 21:20'!
braceExpressionWith: expressions and: lastExpression
	
	^ self node: 'braceExpression' withoutNils: 
		((expressions
			ifNotNil: [ expressions ]
			ifNil: [ {} ])
				asOrderedCollection
					add: lastExpression;
					yourself)! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/16/2010 16:46'!
byteArray =
	// Byte array can only contain number-objects, don't pack them into nodes
	
	$# ch($[)
		(
			(spaces number:number [ number first ]:byte
			?[ (byte isInteger) & (byte <= 255) & (byte >= 0)] 
			) -> [ byte ]
		)*:contents
	ch($])
	-> [ self node: 'byteArray' with: contents ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 21:19'!
cascadedExpression =
	// Constructs a node, whose first node is the receiver and all further nodes are messages sent to that receiver
	
	(keywordExpression | binaryExpression | unaryExpression):mainExpression
	(
		ch($;)
		(
		((spaces binarySelector:selector (unaryExpression | primary):argument) -> [ self node: 'binaryExpression' with: { selector. argument }])
		| (((spaces keyword:selector (binaryExpression | unaryExpression | primary):argument) -> 
				[ selector -> argument])+:selectorsAndArguments -> [ (self keywordMessage: selectorsAndArguments) name: 'keywordExpression' ])
		| (spaces unarySelector:selector -> [ self node: 'unaryExpression' with: { selector } ])
		):cascade
		-> [ cascade ]
	)+:cascades
	-> [ self cascadedExpression: mainExpression with: cascades ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/7/2010 13:16'!
cascadedExpression: mainExpression with: cascades
	"The receiver of the mainExpression is the receiver of the whole cascade.
	It is the first node, the other nodes are the messages sent to that receiver"
	
	^ self node: 'cascadedExpression' withoutNils: 
		((cascades
			ifNotNil: [ cascades ]
			ifNil: [ {} ])
				asOrderedCollection
					addFirst: mainExpression;
					addFirst: mainExpression removeFirst;
					yourself)! !

!S2JParser methodsFor: 'ometa helpers' stamp: 'ag 11/30/2010 11:01'!
ch :c =
	// This reads a given element and all spaces before it and return the element
	// ch was supposed to mean character, but this can be applied to any object
	// Called like this: ch($=)
	
	spaces:comment exactly(c)
	-> [ comment ]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/7/2010 10:48'!
character =
	// The method in the super class is #char, don't confuse it!!
	
	( ($$ <anything>:value) | (seq('Character space') -> [ $  ]):value )
	-> [ self node: 'character' with: { value asCharacter } ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/16/2010 16:11'!
consumedBy: aBlock
	
	| result |
	result := super consumedBy: aBlock.
	result isString
		ifFalse: [ result := S2JNode concatenate: result separatedBy: '' ].
	^ result! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 16:34'!
doItSnippet =
	
	temporaries?:temps
	statements?:statements
	-> [ self node: 'doItSnippet' withoutNils: { temps. statements } ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/2/2010 09:41'!
expression =
	
	((spaces identifier:identifier (token(':=') | ch($_))) -> [ identifier ])*:variableNames 
	(cascadedExpression | keywordExpression | binaryExpression | unaryExpression | primary):expressionBody
	
	// First child is the expressionBody, further children are names of variables, that are assigned by this expression
	-> [ self node: 'expression' withoutNils: ({ expressionBody }, variableNames) ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/13/2010 20:28'!
extractCommentOf: anOrderedCollection
	
	| result |
	true ifTrue: [^ nil]. "TODO skip all comments for now..."
	result := ''.
	anOrderedCollection do: [:item |
		item name = 'comment' ifTrue: [
			result := result , item first
			]].
	^ result isEmpty
		ifTrue: [nil]
		ifFalse: [self node: 'comment' with:{result}]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/7/2010 11:29'!
identifier =
	
	nodeNamed(#identifierBase. 'identifier')! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 11/30/2010 11:03'!
identifierBase =
	
	<letter letterOrDigit*>! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 11/22/2010 16:34'!
keyword =
	
	<identifierBase $:>:selector
	-> [ selector asSymbol ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:06'!
keywordExpression =
	
	(binaryExpression | unaryExpression | primary):receiver
	keywordExpressionMessage:message
	-> [self node: 'keywordExpression' with: { receiver }, message ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:06'!
keywordExpressionMessage =
	
	(((spaces keyword:selector ( binaryExpression | unaryExpression | primary ):argument) -> [ selector -> argument ])+:selectorAndArguments)
	-> [ self keywordMessage: selectorAndArguments ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/2/2010 10:31'!
keywordMessage: selectorAndArgumentNames
	"selectorAndArgumentNames contains associations, the part of the selector and the argument name.
	Resulting S2JNode will have the selector as symbol on the first position and the argumentNames at the other positions."
	
	| selector result |
	selector := ''.
	result := self node: 'keyword' with: {}.
	selectorAndArgumentNames do: [ :each |
		selector := selector, each key.
		result add: each value].
	^ result
		addFirst: selector asSymbol;
		yourself! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/16/2010 16:12'!
literalReservedWord =
	// Copy of reservedWord, with only the static values
	
	<(seq('true') | seq('false') | seq('nil'))>:reservedWord
	&(binarySelector | space | end | $] | $. | $; | $} | $)) // Look ahead to ensure, that this token ends here, don't match e.g. self2, but match self/2
	-> [ self node: 'reservedWord' with: { reservedWord }]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/7/2010 15:23'!
literalToken =
	// Anything, that can be evaluated to an object without context
	
	literalTokenBase
|	(($# spaces array:array) -> [ array ])! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/16/2010 16:08'!
literalTokenBase =
	// Things, that can be evalutated to an object without any context (array-literals excluded)
	
	literalReservedWord
|	number
|	symbol
|	character
|	string
|	byteArray! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 13:56'!
messagePattern =
	
	((spaces keyword:selectorPart spaces identifier:argumentName) -> [ selectorPart -> argumentName ])+:selectorAndArgumentNames
	-> [ self keywordMessage: selectorAndArgumentNames ]
|	spaces binarySelector:selector spaces identifier:argumentName
	-> [ self node: 'binary' with: { selector. argumentName } ]	
|	spaces unarySelector:unarySelector
	-> [ self node: 'unary' with: { unarySelector } ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 09:11'!
method =
	// Only one temporaries-declaration allowed, but can be before or after primitive-declaration
	
	messagePattern:head
	temporaries?:temps
	primitiveDeclaration*:primitives
	temporaries?:secondTemps ( ?[secondTemps isNil]  | (?[temps isNil] [secondTemps]:temps) )
	statements?:statements
	
	-> [ self node: 'method' withoutNils: { head. temps }, primitives, { statements } ]! !

!S2JParser methodsFor: 'ometa helpers' stamp: 'ag 12/7/2010 11:10'!
nodeNamed :aRule :aNodeName =
	// Helper rule to encapsulate the result of a rule into a node
	
	apply(aRule):result
	-> [ self node: aNodeName asString with: { result } ]! !

!S2JParser methodsFor: 'parse easy' stamp: 'LT 12/6/2010 14:37:16.251'!
number =
	// Called that way because of super-class-method
	// The string is parsed once, assuring, that
	
	<
		($-? digit+ $r)?
		$-?
		(digit | upper)+
		($. (digit | upper)+)?
		($e ($- | $+)? (digit | upper)+)?
	>:result
	?[ (self class parseNumber: result) notNil ]
	-> [ self node: 'number' with: {self class parseNumber: result} ]
	
	// An alternative way to evaluate a number...
	| ($# <digit>:value) -> [ self node: 'number' with: {value asNumber} ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/16/2010 23:55'!
primary =
	// something, that evaluates to an object
	
	spaces (literalToken | reservedWord | identifier):result -> [ result ]
|	block
|	braceExpression
|	ch($() expression:expr ch($)) -> [ expr name: 'paranthesizedExpression'; yourself ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 13:40'!
primitiveDeclaration =
	// Reads generally all primitive declarations, there are many of them
	// <primitive: 'a'> <primitive: 2> <primitive: 'a' module: 'b'> <version: 'ab'> <command> etc. etc.
	
	ch($<)
		(
			primitiveDeclarationRule(#keywordExpressionMessage)
			| (space primitiveDeclarationRule(#binaryExpressionMessage))
			| primitiveDeclarationRule(#unaryExpressionMessage)
		):message
	ch($>)
	-> [ self node: 'primitiveDeclaration' with: { message } ]! !

!S2JParser methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:31'!
primitiveDeclarationRule :aRule =
	// Read everything, that is inside the <>-primitive-declaration; write it back on the input stream, followed
	// by input, that will not be matched. Apply the rule and read the fake-input. Return the result after applying the rule.
	
	// This allows things, that are forbidden, like <primive: a> (a is an identifier and has been accepted, because it's also a unarySelector
	
	<
		((
			<spaces (literalToken | unarySelector | binarySelector | keyword)>:input ?[ (input includesSubString: '>') not ]
		) -> [ input ])*
	>:primitiveInput
	[ self apply: aRule withArgs: primitiveInput, '^^' ]:result
	$^ $^
	-> [ result ]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/16/2010 16:10'!
reservedWord =
	
	<(seq('true') | seq('false') | seq('nil') | seq('self') | seq('super') | seq('thisContext') | seq('homeContext'))>:reservedWord
	&(binarySelector | space | end | $] | $. | $; | $} | $)) // Look ahead to ensure, that this token ends here, don't match e.g. self2, but match self/2
	-> [ self node: 'reservedWord' with: { reservedWord }]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/13/2010 18:57'!
space =
	// A comment is equivalent to a space-character.
	// spaces are ignored (return nil), but comments result in a special node and are collected
	
	^space -> [ nil ]
	| (($" <(~$" anything)*>:result $") -> [ self node: 'comment' with: { result } ])! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 11/21/2010 13:46'!
specialCharacter =
	
	$+ | $* | $/ | $\ | $~ | $< | $> | $= | $@ | $% | $& | $? | $!! | $` | $,! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 18:58'!
statements =
	
	(expression?:expr ch($.) -> [ expr ] )*:expressions
	(ch($^)?:returnSign expression:lastExpression ch($.)? ~expression)?
	-> [ self statementsWithExpressions: expressions lastExpression: lastExpression returnSign: returnSign ]! !

!S2JParser methodsFor: 'helpers' stamp: 'ag 12/15/2010 11:17'!
statementsWithExpressions: expressions lastExpression: lastExpression returnSign: returnSign
	"Build the contents of a statements-node from the information gathered while parsing 'statements'"
	
	"Rename the last expression, if it was a return-expression"
	lastExpression notNil & returnSign notNil ifTrue: [
		lastExpression name = 'expression'
			ifTrue: [ lastExpression name: 'returnExpression' ]
			ifFalse: [ self error: 'Unexpected node at return-sign: ', lastExpression printString ]].
	expressions
		add: lastExpression;
		reject: [ :each | each isNil ].
	^ self node: 'statements' withoutNilsNotEmpty: expressions! !

!S2JParser methodsFor: 'parse easy' stamp: 'mh 12/11/2010 00:38'!
string =
	// Called that way because of super-class-method
	
	$' ((~$' anything) | (($' $') -> [ $' ]))*:values $'
	-> [ self node: 'string' with: { values asOrderedCollection inject: '' into: [ :a :b | a, b asString ] } ]! !

!S2JParser methodsFor: 'parse easy' stamp: 'ag 12/7/2010 17:23'!
symbol =
	
	$# spaces (symbolBase | (string:stringSymbol -> [ stringSymbol first ])):value 
	-> [ self node: 'symbol' with: { value asSymbol } ]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/13/2010 21:45'!
symbolBase =
	// This does not return a symbol, just consume input. Inside of array, symbols can be represented without
	// the #-character
	
	binarySelector
|	<keyword+ identifierBase>
|	<keyword+>
|	identifierBase
|	($: | $. | ($[ $]) | ${ | $} | $] | $^):result -> [ result asSymbol ]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/16/2010 16:09'!
symbolBaseForArray =
	
	(~literalReservedWord
	(
		symbolBase
		| $[
	):result)
	-> [ result asSymbol ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 11/21/2010 19:10'!
temporaries =
	
	ch($|)
		(spaces identifier:identifier -> [ identifier ])*:variableNames
	ch($|)
	-> [ self node: 'temporaries' with: variableNames ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:07'!
unaryExpression =
	
	(unaryExpression | primary):receiver unaryExpressionMessage:message
	-> [ self node: 'unaryExpression' with: {receiver. message} ]! !

!S2JParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:07'!
unaryExpressionMessage =
	
	spaces unarySelector:message
	-> [ message ]! !

!S2JParser methodsFor: 'parse tokens' stamp: 'ag 12/2/2010 11:51'!
unarySelector =
	
	identifierBase:selector ~$:
	-> [ selector asSymbol ]! !

OrderedCollection subclass: #S2JNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JNode commentStamp: 'ag 11/18/2010 13:09' prior: 0!
This is only a named collection, that is supposed to hold further collections or strings to form a tree!

!S2JNode class methodsFor: 'helpers' stamp: 'ag 12/1/2010 16:20'!
concatenate: anOrderedCollection separatedBy: aString
	
	^ anOrderedCollection 
		inject: '' 
		into: 
			[ :sum :each | 
				sum isEmpty 
					ifTrue: [each asString] 
					ifFalse: [sum, aString, each asString]]! !

!S2JNode class methodsFor: 'instance creation' stamp: 'ag 11/18/2010 13:08'!
named: aString with: anOrderedCollection
	
	^ self new
		name: aString;
		addAll: anOrderedCollection;
		yourself! !

!S2JNode class methodsFor: 'instance creation' stamp: 'ag 11/18/2010 13:58'!
named: aString withoutNils: anOrderedCollection
	
	anOrderedCollection ifNil: [ ^ nil ].
	^ self
		named: aString
		with: (anOrderedCollection reject: [ :each | each isNil])! !

!S2JNode class methodsFor: 'instance creation' stamp: 'ag 11/21/2010 19:15'!
named: aString withoutNilsNotEmpty: anOrderedCollection
	"Returns nil, if resulting node would be empty"
	
	| result |
	result := self named: aString withoutNils: anOrderedCollection.
	^ (result isNil or: [result isEmpty])
		ifTrue: [ nil ]
		ifFalse: [ result ]! !

!S2JNode methodsFor: 'comparing' stamp: 'ag 11/21/2010 19:19'!
= anObject
	
	^ super = anObject and: 
		[ name = anObject name ]! !

!S2JNode methodsFor: 'testing' stamp: 'ag 12/16/2010 15:58'!
includesChildNamed: aString
	
	^ self name = aString
		or: [ self anySatisfy: [ :node | 
			(node isKindOf: S2JNode) and: [
			node includesChildNamed: aString ] ] ]! !

!S2JNode methodsFor: 'testing' stamp: 'LT 12/1/2010 14:06:25.154'!
isArrayNode

	^ name = 'array' or: [name = 'byteArray' or: [name = 'braceExpression']]! !

!S2JNode methodsFor: 'accessors' stamp: 'ag 11/18/2010 13:07'!
name
	
	^ name! !

!S2JNode methodsFor: 'accessors' stamp: 'ag 11/18/2010 13:07'!
name: aString
	
	name := aString! !

!S2JNode methodsFor: 'printing' stamp: 'ag 11/19/2010 00:39'!
printString
	
	| result first |
	first := true.
	result := name, ' ('.
	self do: [ :each |
		first ifTrue: [first := false] ifFalse: [result := result, ', '].
		result := result,  each printString].
	^ result, ')'! !

TestCase subclass: #S2JTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Tests'!

S2JTestCase subclass: #S2JAbstractTest
	instanceVariableNames: 'currentRule nilResultAllowed checkResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Tests'!

!S2JAbstractTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:15'!
converterClass
	
	self subclassResponsibility! !

!S2JAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultCheckResults
	
	^ true! !

!S2JAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:24'!
defaultCurrentRule
	
	^ nil! !

!S2JAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultNilResultsAllowed
	
	^ false! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:29'!
assert: aString matches: aRule
	"In most cases, throws an error when failing (hard fail)"
	
	| result |
	result := self class converterClass convert: aString as: aRule.
	self nilResultAllowed ifFalse: [ self assert: result notNil ].
	^ result! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:17'!
assert: aString matches: aRule andProduces: anObject
	"In most cases, throws an error when failing (hard fail). #= Checks collections deeply."
	
	| result |
	result := self assert: aString matches: aRule.
	self checkResults ifTrue: [ self assert: result = anObject ].
	^ result! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/13/2010 08:46'!
assert: aString matches: aRule andProducesNode: aCollection
	"Matches the string to the rule and compares the result to an S2JNode containing the given collection and named like the rule.
	(Follows a convention)."
	
	| result |
	result := self assert: aString matches: aRule.
	self checkResults ifTrue: [ self assert: result = (self node: aRule asString with: aCollection) ].
	^ result! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:57'!
assertConverting: anInputString containsNodeNamed: aNodeName
	
	^ self assert: 
		(( self assertMatches: anInputString )
			includesChildNamed: aNodeName).! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString
	"Checks against the currentRule"
	
	self
		assertFails: aString
		toMatch: self currentRule.! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString toMatch: aRule
	
	self
		should: [ self assert: aString matches: aRule ]
		raise: OM2Fail
		description: 'Matching should have failed but didn''t!!'.! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:57'!
assertMatches: aString
	"Check against the currentRule"
	
	^ self assert: aString matches: self currentRule! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProduces: anObject
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProduces: anObject! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProducesNode: aCollection
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProducesNode: aCollection! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults
	^ checkResults! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults: aBoolean
	checkResults := aBoolean! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule
	^ currentRule! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule: aSymbol
	currentRule := aSymbol! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:56'!
denyConverting: anInputString containsNodeNamed: aNodeName
	
	self deny: 
		(( self assertMatches: anInputString )
			includesChildNamed: aNodeName).! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:18'!
exampleMethod1
	
	"Comment"
	self class.
	^ [ JsGlobal alter: 'example'].! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:18'!
exampleMethod2
	
	| temporaries |
	< primitiveDecl: 1 >
	"Comment"
	self class.
	self
		a: 1;
		b: 2;
		c.
	^ [ JsGlobal alter: 'example'].! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:22'!
""exampleMethod3""
	""
	""<"" primitiveDecl: ""1 "">""
	""
	""| ""temporariesAfterPrimitiveDecl"" |""
	"Comment"
	""self"" class"".""
	self""
		""a:"" 1"";""
		""b: ""2"";""
		""c"".""
	""^"" [""JsGlobal ""alter:"" 'example'""]"".""! !

!S2JAbstractTest methodsFor: 'initialization' stamp: 'ag 12/13/2010 09:24'!
initialize
	
	super initialize.
	self
		nilResultAllowed: self class defaultNilResultsAllowed;
		checkResults: self class defaultCheckResults;
		currentRule: self class defaultCurrentRule.! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
nilResultAllowed
	^ nilResultAllowed! !

!S2JAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
nilResultAllowed: aBoolean
	nilResultAllowed := aBoolean! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
node: aString
	
	^ S2JNode named: aString with: {}! !

!S2JAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
node: aString with: aCollection
	
	^ S2JNode named: aString with: aCollection! !

!S2JAbstractTest methodsFor: 'private' stamp: 'ag 12/13/2010 09:30'!
performTest
	
	self class = S2JAbstractTest
		ifTrue: [ "Just ignore the abstract tests" ]
		ifFalse: [ super performTest ].! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:20'!
testExampleMethods
	
	self class converterClass
		convertMethod: #exampleMethod1 of: self class;
		convertMethod: #exampleMethod2 of: self class;
		convertMethod: #exampleMethod3 of: self class.! !

!S2JAbstractTest methodsFor: 'test general' stamp: 'ag 12/13/2010 08:49'!
testRandomMethods
	"Match some random methods from the image.
	Test will not fail, just print errors to the transcript, as this is no real test-case..."
	
	| result |
	result := self class converterClass convertRandomMethods: 10.
	Transcript cr; cr; show: self class name, ': ', result.! !

S2JAbstractTest subclass: #S2JParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Tests'!

!S2JParserTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:24'!
converterClass
	
	^ S2JParser! !

!S2JParserTest methodsFor: 'testing' stamp: 'ag 12/16/2010 17:03'!
expectedFailures
	
	^ #( #testComments )! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 17:16'!
testArray
	
	self
		currentRule: #array;
		
		assertMatches: '()' andProducesNode: {};
		assertMatches: '(:)' andProducesNode: { self node: 'symbol' with: { #: } };
		assertMatches: '(  )  ' andProducesNode: {};
		assertMatches: '( 2. 1) ';
		assertMatches: '( 2. 1 [ ] ^ 23 { } ) ';
		assertMatches: '(  1 2   3) ' andProducesNode: 
			{self node: 'number' with:{1}. self node: 'number' with:{2}. self node: 'number' with:{3}};
		assertMatches: '(''aa'' 1 ''b1'' 32)' andProducesNode: 
			{self node: 'string' with: { 'aa' }. self node: 'number' with: {1}. self node: 'string' with: { 'b1' }. self node: 'number' with: {32}};
		assertMatches: '(#abc     11    ''a''   )' andProducesNode: 
			{self node: 'symbol' with: {#abc}. self node: 'number' with: {11}. self node: 'string' with: {'a'}};
		assertMatches: '(  ( 1 2 3    ''2'')   #a  ''c''   )' andProducesNode: 
			{self node: 'array' with: {self node: 'number' with: {1}. self node: 'number' with: {2}. self node: 'number' with: {3}. self node: 'string' with: { '2' }}.
			self node: 'symbol' with: {#a}. self node: 'string' with: {'c'}};
		assertMatches: '($a     11    ''a''   #a2   #(1 2   $2) )  ' andProducesNode: { self node: 'character' with: { $a }. self node: 'number' with: {11}. self node: 'string' with: {'a'}. self node: 'symbol' with: {#a2}. self node: 'array' with: {self node: 'number' with: {1}. self node: 'number' with: {2}. self node: 'character' with: { $2 }}};
		assertMatches: '( a )' andProducesNode: { self node: 'symbol' with: {'a'}};
		assertMatches: '( a b )' andProducesNode: {self node: 'symbol' with: {'a'}. self node: 'symbol' with: {'b'}} ;
		assertMatches: '(d ((b ((a))) (c)))' andProducesNode: {self node: 'symbol' with: {'d'}. self node: 'array' with: {self node: 'array' with: {self node: 'symbol' with: {'b'}. 
			self node: 'array' with: {self node: 'array' with: {self node: 'symbol' with: {'a'}}}}. self node: 'array' with: {self node: 'symbol' with: {'c'}}}};
		assertMatches: '( self a:bc == |? ?!!!! )  ' andProducesNode: {self node: 'symbol' with: {'self'}. self node: 'symbol' with: {'a:bc'}. 
			self node: 'symbol' with: {'=='}. self node: 'symbol' with: {'|'}. self node: 'symbol' with: {'?'}. self node: 'symbol' with: {'?!!!!'}};
		assertMatches: '( self #( aa 1 ) ( ''a'' #1 #ab: ab:))  ' andProducesNode: { self node: 'symbol' with: {'self'}. self node: 'array' with: {self node: 'symbol' with: {'aa'}. self node: 'number' with: {1}. }. self node: 'array' with: { self node: 'string' with: { 'a' }. self node: 'number' with: {1}. self node: 'symbol' with: {'ab:'}. self node: 'symbol' with: {'ab:'} }} ;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '(';
		assertFails: '#()';
		assertFails: '#(';
		assertFails: '{1}';
		assertFails: ' ( 1 2  )'. "Should not read prepended spaces"! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/16/2010 17:01'!
testBinaryExpression
	
	self
		currentRule: #binaryExpression;
		
		assertMatches: 'a+b' andProducesNode:  (self node:'binaryExpression' with: { self node: 'identifier' with: {'a'} . #+. self node: 'identifier' with: {'b'}} );
		assertMatches: '1 * b' andProducesNode: (self node:'binaryExpression' with: 
			{self node: 'number' with: {1} .#* . self node: 'identifier' with: {'b'}});
		assertMatches: '1 \ b / c' andProducesNode: 
			(self node: 'binaryExpression' with: 
				{ self node: 'binaryExpression' with: {  self node: 'number' with: {1} .  #\  . 
				self node: 'identifier' with: {'b'}} . #/ . self node: 'identifier' with: {'c'}} );
		
		assertFails: 'a 2';
		assertFails: 'a: 2';
		assertFails: '+ 2'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 11/21/2010 20:02'!
testBinarySelector
	"Would be cool to find all the binary messages in the image and test them..."
	
	self
		currentRule: #binarySelector;
		
		"special cases: single pipe and single minus"
		assertMatches: '|' andProduces: #|;
		assertMatches: '-' andProduces: #-;
		
		"names starting with a minus"
		assertMatches: '-*' andProduces: #-*;
		assertMatches: '-***' andProduces: #-***;
		assertMatches: '-*%&' andProduces: #-*%&;
		assertMatches: '-*/\' andProduces: #-*/\;
		assertMatches: '-!!?' andProduces: #-!!?;
		assertMatches: '-==' andProduces: #-==;
		
		"mixed characters, check each one"
		assertMatches: '*+' andProduces: #*+;
		assertMatches: '/=\' andProduces: #/=\;
		assertMatches: '~,,,<' andProduces: #~,,,<;
		assertMatches: '>@' andProduces: #>@;
		assertMatches: '%&' andProduces: #%&;
		assertMatches: '?!!' andProduces: #?!!;
		assertMatches: '``' andProduces: #``;
		assertMatches: '+??=' andProduces: #+??=;
		assertMatches: ',!!!!,' andProduces: #,!!!!,;
		
		"Not allowed things"
		assertFails: '';
		assertFails: ' ';
		assertFails: 'w';
		assertFails: '2';
		assertFails: '--';
		assertFails: '||';
		assertFails: '|--';
		assertFails: '%--';
		assertFails: '%||';
		assertFails: '&-&-';
		assertFails: '- %';
		assertFails: ' -';
		assertFails: '& &';
		assertFails: 'w a';
		assertFails: '- -';
		assertFails: '#a a';
		assertFails: '#aa 2'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/16/2010 17:01'!
testBlock
	
	self
		currentRule: #block;
		
		assertMatches: '[]' andProducesNode: { };
		assertMatches: '[  ]' andProducesNode: { };
		assertMatches: '[||]' andProducesNode: {self node: 'temporaries'};
		assertMatches: '[:a|||]' andProducesNode: 
			{ self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'temporaries'};
		assertMatches: '[||a]' andProducesNode: {self node: 'temporaries'. self node: 'statements' with: {self node: 'expression' with: {self node: 'identifier' with: {'a'}}}};
		assertMatches: '[:a|||a]' andProducesNode:
			{ self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'temporaries'. self node: 'statements' with: { self node: 'expression' with: {self node: 'identifier' with: {'a'}}}};
		assertMatches: '[:a||a|a]' andProducesNode: 
			{ self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'temporaries' with: { self node: 'identifier' with: {'a'}}. 
			self node: 'statements' with: { self node: 'expression' with: { self node: 'identifier' with: {'a'}}}};
		assertMatches: '[:a|a|a|a]' andProducesNode:
			{ self node: 'arguments' with: { self node: 'identifier' with: {'a'} }. self node: 'statements' with:
				{ self node: 'expression' with: { self node: 'binaryExpression' with: { self node: 'binaryExpression' with: 
					{ self node: 'identifier' with: {'a'}. #|. self node: 'identifier' with: {'a'} }. #| . 
					self node: 'identifier' with: {'a'}.  }}}};
		assertMatches: '[ :a ]  ' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'a'}}};
		assertMatches: '   [ :a ]  ' andProducesNode: {self node: 'arguments' with: { self node: 'identifier' with: {'a'}}};
		assertMatches: '[ :a :b ]  ' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'a'}. self node: 'identifier' with: {'b'}}};
		assertMatches: '[ :a  :b | ]' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'a'}. self node: 'identifier' with: {'b'}}};
		assertMatches: '  [   :a |   |  a  |   ]  ' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. 
			self node: 'temporaries' with: {self node: 'identifier' with: {'a'}}};
		assertMatches: '[  :a  | a ]  ' andProducesNode:
			{self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. 
			self node: 'statements' with: {self node: 'expression' with: {self node: 'identifier' with: {'a'}}}};
		assertMatches: '[ :a  | a. ^ 1 ]' andProducesNode:
			{self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'statements' with:
				{self node: 'expression' with: {self node: 'identifier' with: {'a'}}. self node: 'returnExpression' with: {self node: 'number' with: {1}}}};
		assertMatches: '[  :a  |  1  ]' andProducesNode:
			{self node: 'arguments' with: {self node: 'identifier' with: {'a'}}. self node: 'statements' with: {self node: 'expression' with: {self node: 'number' with: {1}}}};
		assertMatches: '[  :b  |   []  ]' andProducesNode:
			{self node: 'arguments' with: {self node: 'identifier' with: {'b'}}. self node: 'statements' with: {self node: 'expression' with: { self node: 'block'}}};
		
		"Can also leave spaces between : and the argument-name !!"
		assertMatches: '[ :  i | ]' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'i'}}};
		assertMatches: '[ :  i :  d | ]' andProducesNode: {self node: 'arguments' with: {self node: 'identifier' with: {'i'}. self node: 'identifier' with: {'d'}}};
		
		assertFails: '[]]';
		assertFails: '[[]';
		assertFails: '[::a]';
		assertFails: '[ :a | b';
		assertFails: '[ :a |||| b]';
		assertFails: '[ | :a | b]';
		assertFails: '[ || :a | b]';
		assertFails: '[ :a || b]';
		assertFails: '[ :a | :b  ]';
		assertFails: '[ :a || :b|]';
		assertFails: '[ :a | b| :a]';
		assertFails: '[ :a :1 | b]';
		assertFails: '[ aaaa"] ';
		assertFails: '[ "aaa"a"] ';
		assertFails: '[ "aaaa] '.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/16/2010 17:02'!
testBraceExpression
	
	self
		currentRule: #braceExpression;
		
		assertMatches: '{}' andProducesNode: { };
		assertMatches: '  {  }   ' andProducesNode: { };
		assertMatches: '{1}' andProducesNode: {self node: 'expression' with: {self node: 'number' with: {1}}};
		assertMatches: '  {  11 }  ' andProducesNode: {self node: 'expression' with: {self node: 'number' with: {11}}};
		assertMatches: '  {  11. }  ' andProducesNode: {self node: 'expression' with: { self node: 'number' with: {11}}};
		assertMatches: '{ 1.   2}' andProducesNode: {self node: 'expression' with: 
			{self node: 'number' with: {1}}. self node: 'expression' with: { self node: 'number' with: {2}}};
		assertMatches: '{1.2}' andProducesNode: {self node: 'expression' with: {self node: 'number' with: {1.2}}};
		assertMatches: '{1. 2}' andProducesNode: { self node: 'expression' with: {self node: 'number' with: {1}}. 
			self node: 'expression' with: {self node: 'number' with: {2}}};
		assertMatches: '{1. ''.'' .}' andProducesNode: { self node: 'expression' with: {self node: 'number' with: {1}}. 
			self node: 'expression' with: {self node: 'string' with: { '.'}}};
		assertMatches: '{1  .  2  .}' andProducesNode: { self node: 'expression' with: {self node: 'number' with: {1}}. 
			self node: 'expression' with: {self node: 'number' with: {2}}};		
		
		assertFails: '.{}.';
		assertFails: '{1 .. 2}';
		assertFails: '{ 1  . 2 ..}';
		assertFails: '{.1.2}';
		assertFails: '{..1.}';
 		assertFails: '{ "bb}';
 		assertFails: '{ "b "   .  b"}'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/9/2010 13:40'!
testByteArray
	
	self
		currentRule: #byteArray;
		
		assertMatches: '#[1]' andProducesNode: {1};
		assertMatches: '#  [  1  ]  ' andProducesNode: {1};
		assertMatches: '#[]' andProducesNode: {};
		assertMatches: '#   [1 2 3 ]' andProducesNode: {1. 2. 3.};
		assertMatches: '#[255 000 000 123 255]' andProducesNode: {255. 0. 0. 123. 255};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#[ 1';
		assertFails: '  #[ 1 ]';
		assertFails: '# [ 1.2 ]';
		assertFails: '#[ 256 1 00]';
		assertFails: '#[ -1 ]';
		assertFails: '#[ +1 ]';
		assertFails: '#[ #[ 1 ] ]  ';
		assertFails: '#( 255 )'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 10:09'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		assertMatches: 'Transcript  show:2;cr' andProducesNode: (self node: 'cascadedExpression' with:
				{self node: 'identifier' with:{'Transcript'}.  self node: 'keywordExpression' with: {#show: . self node: 'number' with: {2}} .self node:'unaryExpression' with:{#cr}});
		"assertMatches: 'Transcript  show:2 ""Comment"";cr' andProducesNode: (self node: 'cascadedExpression' with:
				{self node: 'identifier:' with:{'Transcript'}. self node: 'keywordExpression' with: {#show: . self node: 'number' with: {2}} .self node:'unarayExpression' with:{self node:'comment' with:{'Comment'} . #cr} } );" "comments are not yet stored correctly"

		assertFails: 'Transcript  show:2 "Comment;cr';				
		assertFails: 'Transcript show:1'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 11:14'!
testCharacter
	
	self
		currentRule: #character;
		
		assertMatches: '$c' andProducesNode: { $c };
		assertMatches: '$&' andProducesNode: { $& };
		assertMatches: '$ ' andProducesNode: { $ };
		assertMatches: '$`' andProducesNode: { $` };
		assertMatches: 'Character space' andProducesNode: { $  };
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'a';
		assertFails: '`';
		assertFails: ' $a';
		assertFails: '$$$';
		assertFails: '$  a';
		assertFails: '$av';
		assertFails: '$ a'.! !

!S2JParserTest methodsFor: 'test general' stamp: 'ag 12/16/2010 17:03'!
testComments
	
	self
		currentRule: #binaryExpression;
		assertMatches: '1 "Comment "* b' andProducesNode: (self node:'binaryExpression' with: 
			{ self node: 'comment' with:{ 'Comment ' } . self node: 'number' with: {1}. #*. 
			self node: 'identifier' with: {'b'}});
		
		currentRule: #block;
		assertMatches: '"aaaaa" "aaa"[]'  andProducesNode: { self node:'comment' with: {'aaaaaaaaa' } };
		assertMatches: '"aaaaa" ["a aa"]'  andProducesNode: { self node:'comment' with: {'aaaaa' } . self node:'comment' with: {'a aaa' }};
		assertMatches: '[ "a aaa"] '  andProducesNode: { self node:'comment' with: {'a aaa' } };
		assertMatches: '[ "aaaa"] '  andProducesNode: { self node:'comment' with: {'aaaa' } };
		
		assertMatches: '"aaa"{}' andProducesNode: { self node: 'comment' with: {'aaa' } };
		assertMatches: '"aaa"{ "bbb"}' andProducesNode: { self node: 'comment' with: {'aaabbb' } };
		assertMatches: '{ "bbb"}' andProducesNode: { self node: 'comment' with: {'bbb' } }.! !

!S2JParserTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 16:54'!
testExpressionAssignment
	
	self
		currentRule: #expression;
		
		assertMatches: 'a' andProducesNode: {self node: 'identifier' with: {'a'}};
		assertMatches: 'a := b' andProducesNode: {self node: 'identifier' with: {'b'}. 
			self node: 'identifier' with: {'a'}};
		assertMatches: '  a   :=   b  ' andProducesNode: {self node: 'identifier' with: {'b'}. 
			self node: 'identifier' with: {'a'}};
		assertMatches: 'a := b := c := 1' andProducesNode: {self node: 'number' with: {1}. 
			self node: 'identifier' with: {'a'}. self node: 'identifier' with: {'b'}. self node: 'identifier' with: {'c'}};
		assertMatches: '  a    :=  b  :=  c :=   1' andProducesNode: {self node: 'number' with: {1}. 
			self node: 'identifier' with: {'a'}. self node: 'identifier' with: {'b'}. self node: 'identifier' with: {'c'}};
		assertMatches: 'a _ b' andProducesNode: {self node: 'identifier' with: {'b'}. 
			self node: 'identifier' with: {'a'}};
		assertMatches: 'a := 1';
		assertMatches: 'a := b := 1';
		assertMatches: 'a := b := c := d';
		assertMatches: '   a     :=      a     ';
		assertMatches: '   a     _   1 ';
		assertMatches: 'a:=1';
		assertMatches: 'a:=1.0';
		assertMatches: 'a:=b:=1.0';
		assertMatches: 'a_v_1';
		
		assertFails: 'a : = b';
		assertFails: ' := b';
		assertFails: 'a := ';
		assertFails: 'a := b :=';
		assertFails: 'a := b := 1 := a';
		assertFails: 'a := := b   ';
		assertFails: 'a _ _ b';
		assertFails: 'a __ b';
		assertFails: 'a :=:= b';
		assertFails: 'a := b v := a';
		assertFails: 'a  b := a ';
		assertFails: 'a := 1 := b';
		assertFails: 'a: := b';
		assertFails: 'a: _ b';
		assertFails: 'a :_ b';
		assertFails: 'a := 1 := 2:=f';
		assertFails: 'a __ b';
		assertFails: 'a : = b'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'LT 12/6/2010 11:22:53.039'!
testIdentifier
	
	self
		currentRule: #identifier;
		
		assertMatches: 'abc' andProducesNode: {'abc'};
		assertMatches: 'a1' andProducesNode: {'a1'};
		assertMatches: '1' andProducesNode: {'1'};
		assertMatches: 'aaaaaaaa1233333' andProducesNode: {'aaaaaaaa1233333'};
		assertMatches: '' andProducesNode: {''};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 11/22/2010 11:30'!
testKeywordSelector
	
	self
		currentRule: #keyword;
		
		assertMatches: 'abc:' andProduces: #abc:;
		assertMatches: 'a1:' andProduces: #a1:;
		assertMatches: '1:' andProduces: #1:;
		assertMatches: 'aaaaaaaa1233333:' andProduces: #aaaaaaaa1233333:;
		assertMatches: ':' andProduces: #:;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc';
		assertFails: 'abc<<'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/13/2010 09:27'!
testMethod
	
	self
		currentRule: #method;
		
		assertFails: 'a |a| <p> |a|'. "Don't allow two temporaries-declarations"! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'LT 12/6/2010 11:22:08.233'!
testNumber
	
	self
		currentRule: #number;
		
		assertMatches: '1' andProducesNode: {1};
		assertMatches: '0' andProducesNode: {0};
		assertMatches: '123' andProducesNode: {123};
		assertMatches: '112345678' andProducesNode: {112345678};
		assertMatches: '000' andProducesNode: {0};
		assertMatches: '-000' andProducesNode: {0};
		assertMatches: '-1' andProducesNode: {-1};
		assertMatches: '-1.22' andProducesNode: {-1.22};
		assertMatches: '1.22e23' andProducesNode: {1.22e23};
		assertMatches: '122e23' andProducesNode: {12200000000000000000000000};
		assertMatches: '35r35' andProducesNode: {35r35};
		assertMatches: '-35r35' andProducesNode: {-35r35};
		assertMatches: '22r12.12' andProducesNode: {22r12.12};
		assertMatches: '22r12.12e12' andProducesNode: {22r12.12e12};
		assertMatches: '-22r-12.12e12' andProducesNode: {-22r-12.12e12};
		assertMatches: '22r-12.12e12' andProducesNode: {22r-12.12e12};
		assertMatches: '-22r12.12e12' andProducesNode: {-22r12.12e12};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '+1';
		assertFails: '+1.2';
		assertFails: '+23r23.3';
		assertFails: '+23r+233.3';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: 'abc';
		assertFails: '<<'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 15:35'!
testPrimitiveDeclaration
	
	self
		currentRule: #primitiveDeclaration;
		
		assertMatches: '<a:1b:1>';
		assertMatches: '<a>';
		assertMatches: '<  a>';
		assertMatches: '  <  a  >';
		assertMatches: '< | 1>';
		assertMatches: '< == 2>';
		assertMatches: '<  var: ''anc'' >';
		assertMatches: '< & ''add''>';
		assertMatches: '< abc: 22 dfe: 23>';
		
		assertFails: '<1>';
		assertFails: '< 1 2 >';
		assertFails: '<a: 1 1>';
		"assertFails: '<v: d>';" "These should not match, but match currently. Never mind, is not allowed by the compiler"
		"assertFails: '<d: 2 d: e>';"
		"assertFails: '< | d >';"
		assertFails: '<''2''>';
		assertFails: '<| 1>';
		assertFails: '<< 2>';
		assertFails: '< > 2>';
		assertFails: '<> 2>';
		assertFails: '< a: 2 ';
		assertFails: '< a ';
		assertFails: '< | 2 '.! !

!S2JParserTest methodsFor: 'test general' stamp: 'ag 12/13/2010 08:42'!
testRandomMethods
	
	super testRandomMethods! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/16/2010 16:01'!
testReservedWord
	
	self
		currentRule: #statements;
		
		assertConverting: '1 a; b: self; c' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. self}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. nil}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{true|nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil.{true}}' containsNodeNamed: 'reservedWord';
		denyConverting: '{1. self2. true12}' containsNodeNamed: 'reservedWord';
		denyConverting: '{1. aNself}' containsNodeNamed: 'reservedWord';
		denyConverting: '#(1 self super)' containsNodeNamed: 'reservedWord';
		assertConverting: '#(true)' containsNodeNamed: 'reservedWord';
		
		currentRule: #primary;
		
		assertConverting: '(self)' containsNodeNamed: 'reservedWord';
		assertConverting: '(self/1)' containsNodeNamed: 'reservedWord';
		assertConverting: '([self])' containsNodeNamed: 'reservedWord';
		assertConverting: '([self.])' containsNodeNamed: 'reservedWord';
		assertMatches: '(self2)' andProduces: (self node: 'paranthesizedExpression' with: { self node: 'identifier' with: { 'self2' }});
		denyConverting: '([self2])' containsNodeNamed: 'reservedWord'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 15:53'!
testStatements

	"TODO Not complete test !! Write more !! " 
	
	self
		currentRule: #statements;
		nilResultAllowed: true;
		
		assertMatches: '...';
		assertMatches: 'a. b. ^ c';
		assertMatches: 'a.b.c';
		assertMatches: '1 a. b d: d d: 1. 2. ^ a d: d f: 2';
		assertMatches: '  a  .  b   .. . . . .. . . . .   c.  ^ 1.';
		
		assertFails: ' a. ^ 1...';
		assertFails: ' 1. a ^ 1';
		assertFails: '^ d d. 1';
		assertFails: '^ .';
		assertFails: '^....';
		assertFails: '^^'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/1/2010 17:35'!
testString
	
	self
		currentRule: #string;
		
		assertMatches: '''a''' andProduces: (self node: 'string' with: { 'a' });
		assertMatches: '''''' andProduces: (self node: 'string' with: { '' });
		assertMatches: '''123''' andProduces: (self node: 'string' with: { '123' });
		assertMatches: ''' '''' '''' ''' andProduces: (self node: 'string' with: { ' '' '' ' });
		assertMatches: '''''''123''' andProduces: (self node: 'string' with: { '''123' });
		assertMatches: '''    ''' andProduces: (self node: 'string' with: { '    ' });
		assertMatches: '''"$%&''' andProduces: (self node: 'string' with: { '"$%&' });
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: ''' ''a';
		assertFails: ' ''''';
		assertFails: 'a''''';
		assertFails: '''as';
		assertFails: 'as''';
		assertFails: ''' '' ''';
		assertFails: '''a '' a''';
		assertFails: '''/'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 17:32'!
testSymbol
	
	"TODO extend test, if stringS2J gets extended to support '' inside of a string"
	
	self
		currentRule: #symbol;
		
		assertMatches: '#abc' andProducesNode: {#abc};
		assertMatches: '# ''''' andProducesNode: {#''};
		assertMatches: '#   abc' andProducesNode: {#  abc};
		assertMatches: '#abc1' andProducesNode: {#abc1};
		assertMatches: '#a' andProducesNode: {#a};
		assertMatches: '#''a''' andProducesNode: {#a};
		assertMatches: '#''a b c''' andProducesNode:  {#'a b c'};
		assertMatches: '#''''' andProducesNode: {#''};
		assertMatches: '#''123''' andProducesNode:  {#'123'};
		assertMatches: '#''    ''' andProducesNode: {#'    '};
		assertMatches: '#''"$%&''' andProducesNode: {#'"$%&'};
		assertMatches: '#abc1:' andProducesNode: {#abc1:};
		assertMatches: '#|' andProducesNode: {#|};
		assertMatches: '#-&&' andProducesNode: {#-&&};
		assertMatches: '#-' andProducesNode: {#-};
		assertMatches: '#a:b:c1' andProducesNode: {#a:b:c1};
		assertMatches: '#:' andProducesNode: {#:};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'abc';
		assertFails: '#1abc';
		assertFails: '#""';
		assertFails: '#'' ''a';
		assertFails: '#a''''';
		assertFails: '#''as';
		assertFails: '#as''';
		assertFails: '#'' '' ''';
		assertFails: '#''a '' a''';
		assertFails: '#123';
		assertFails: '###';
		assertFails: '#''/'.! !

!S2JParserTest methodsFor: 'test complex' stamp: 'LT 12/6/2010 11:38:46.1'!
testUnaryExpression
	
	self
		currentRule: #unaryExpression;
		
		assertMatches: 'a b' andProducesNode: { self node: 'identifier' with: {'a'}. #b };
		assertMatches: '1 b' andProducesNode: { self node: 'number' with: {1}. #b };
		assertMatches: 'a b c' andProducesNode: { self node: 'unaryExpression' 
			with: { self node: 'identifier' with: {'a'}. #b }. #c };
		assertMatches: ' a  b c d ' andProducesNode: { self node: 'unaryExpression' with: { self node: 'unaryExpression' with: { self node: 'identifier' with: {'a'}. #b }. #c }. #d };
		assertMatches: '   ''abc''    b1     ' andProducesNode: { self node: 'string' with: { 'abc' }. #b1 };
		
		assertFails: '';
		assertFails: '  ';
		assertFails: 'a';
		assertFails: '  a  ';
		assertFails: 'a  1';
		assertFails: 'a b 1';
		assertFails: 'a || b';
		assertFails: 'a % b';
		assertFails: 'a -|';
		assertFails: 'a b > a';
		assertFails: 'a unary>'.! !

!S2JParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 10:08'!
testUnarySelector
	"Would be cool to find all the unary messages in the image and test them..."
	
	self
		currentRule: #unarySelector;
		
		assertMatches: 'abc' andProduces: #abc;
		assertMatches: 'a1' andProduces: #a1;
		assertMatches: '1' andProduces: #1;
		assertMatches: 'aaaaaaaa1233333' andProduces: #aaaaaaaa1233333;
		assertMatches: '' andProduces: #;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

S2JAbstractTest subclass: #S2JPrettyPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Tests'!

!S2JPrettyPrinterTest class methodsFor: 'testing' stamp: 'lw 1/4/2011 17:46'!
converterClass
	
	^ S2JPrettyPrinter! !

!S2JPrettyPrinterTest class methodsFor: 'testing' stamp: 'lw 1/4/2011 11:23'!
defaultCurrentRule
	
	^ #doItSnippet! !

!S2JPrettyPrinterTest methodsFor: 'test printing' stamp: 'LT 1/4/2011 20:16:26.171'!
testIndention

	self
		assertMatches: '[:e | JsGlobal alert: e. [ :f | f + 1 ]. [ :f | f := f + 2. ^ [JsGlobal alert: f ] ]]'
		andProduces:  
'block(function(e){
    alert(e);
    block(function(f){
        return f._plus(Number(1));});
    return block(function(f){
        f = f._plus(Number(2));
        nonLocalReturn(block(function(){
            return alert(f);}));});})'! !

!S2JPrettyPrinterTest methodsFor: 'test printing' stamp: 'LT 1/4/2011 20:08:04.936'!
testLoop

	self
		assertMatches: '{1. 2. 3} do: [:elem | JsGlobal alert: elem]'
		andProduces: 
'[Number(1), Number(2), Number(3)].do_(block(function(elem){
    return alert(elem);}))'.! !

!S2JPrettyPrinterTest methodsFor: 'test printing' stamp: 'LT 1/4/2011 20:05:54.398'!
testTrueFalse

	self 
		assertMatches: '10 < 5 ifTrue: [ JsGlobal alert: ''small'' ] ifFalse: [ JsGlobal alert: ''big'' ]'
		andProduces:  'Number(10)._less(Number(5)).ifTrue_ifFalse_(block(function(){
    return alert("small");}), block(function(){
    return alert("big");}))'.! !

S2JAbstractTest subclass: #S2JPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Tests'!

!S2JPrinterTest class methodsFor: 'testing' stamp: 'lw 1/4/2011 11:23'!
converterClass
	
	^ S2JPrinter! !

!S2JPrinterTest class methodsFor: 'testing' stamp: 'ag 12/22/2010 13:52'!
defaultCurrentRule
	
	^ #doItSnippet! !

!S2JPrinterTest methodsFor: 'testing' stamp: 'sec 1/4/2011 12:13'!
expectedFailures
	
	^ #( testClientEvaluation )! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'LT 1/4/2011 20:00:26.552'!
testAddition
	
	self
		assertMatches: '3+4'
		andProduces: 'Number(3)._plus(Number(4))'.! !

!S2JPrinterTest methodsFor: 'test printing' stamp: 'srv 1/5/2011 12:38'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		
		assertMatches: 'a b; c'
		andProduces: '(function(){var cascadeReceiver$=a;cascadeReceiver$.b();return cascadeReceiver$.c();}).apply(this)';
		
		assertMatches: 'a b: (a b; d); c'
		andProduces: '(function(){var cascadeReceiver$=a;cascadeReceiver$.b_(((function(){var cascadeReceiver$=a;cascadeReceiver$.b();return cascadeReceiver$.d();}).apply(this)));return cascadeReceiver$.c();}).apply(this)'! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'HK 11/29/2010 16:31'!
testClientEvaluation

	self fail.
	"clientEval: [ JsGlobal alert: 3+4]"! !

!S2JPrinterTest methodsFor: 'test printing' stamp: 'srv 1/5/2011 11:12'!
testEscapingIdentifiers
	
	self
		currentRule: #doItSnippet;
		
		assertMatches: 'Object new'
		andProduces: '_Object._new()';
		
		assertMatches: 'a := true'
		andProduces: 'a=_true'.
	
	self class isOnCIServer ifTrue: [
		self assert: ((S2JCodeFactory new codeForClass: Object) beginsWith: '_Object').
		self assert: ((S2JCodeFactory new codeForClass: Point) beginsWith: 'Point=Class({superClass:_Object')].! !

!S2JPrinterTest methodsFor: 'test general' stamp: 'ag 12/16/2010 21:03'!
testExampleMethods
	
	super testExampleMethods.! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'LT 1/4/2011 20:08:43.496'!
testLoop
	
	self
		assertMatches: '{1. 2. 3} do: [:elem | JsGlobal alert: elem]'
		andProduces: '[Number(1), Number(2), Number(3)].do_(block(function(elem){return alert(elem);}))';
		
		assertMatches: 'arr do: [:elem | JsGlobal alert: elem ]'
		andProduces: 'arr.do_(block(function(elem){return alert(elem);}))';
		
		assertMatches: 'arr do: block'
		andProduces: 'arr.do_(block)'.! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'LT 1/4/2011 20:02:35.053'!
testNonLocalReturn
	
	self
		assertMatches: '
			[ JsGlobal alert: ''outer''.
			[JsGlobal alert: ''inner''.
			 ^self].
			JsGlobal alert: ''end'' ]'
		andProduces: 
			'block(function(){alert("outer");block(function(){alert("inner");nonLocalReturn(this);});return alert("end");})'! !

!S2JPrinterTest methodsFor: 'test printing' stamp: 'LT 1/4/2011 20:00:58.039'!
testPrinting
	
	self
		assert: '1 +/ 2' matches: #binaryExpression andProduces: 'Number(1)._plus_slash(Number(2))';
		assert: '{ 1. a b: c. ''s'' }' matches: #braceExpression andProduces: '[Number(1), a.b_(c), "s"]';
		assert: 'a :=   12 a: 12' matches: #expression andProduces: 'a=Number(12).a_(Number(12))';
		assert: '1 a: 2 b: 3' matches: #keywordExpression andProduces: 'Number(1).a_b_(Number(2), Number(3))';
		assert: '1 a:a b:B. 2 s.' matches: #doItSnippet andProduces: 'Number(1).a_b_(a, B);Number(2).s()';
		assert: '| a b v |' matches: #temporaries andProduces: 'var a;var b;var v';
		assert: '1 bcd' matches: #unaryExpression andProduces: 'Number(1).bcd()';
		assert: '(1 2 3 ''d  '')' matches: #array andProduces: '[Number(1), Number(2), Number(3), "d  "]';
		assert: '#[ 1 2 3 255]' matches: #byteArray andProduces: '[Number(1), Number(2), Number(3), Number(255)]';
		assert: '12.3' matches: #number andProduces: 'Number(12.3)';
		assert: 'self' matches: #reservedWord andProduces: 'this';
		assert: '#a12' matches: #symbol andProduces: '"a12"'.! !

!S2JPrinterTest methodsFor: 'test general' stamp: 'ag 12/13/2010 08:42'!
testRandomMethods
	
	super testRandomMethods! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'LT 1/4/2011 20:12:13.487'!
testSelectorTranslation
	
	| assertBlock |
	assertBlock := [ :squeakSelector :jsFunctionname  | 
		self assert: jsFunctionname equals: (S2JSqueakAstToJsAst jsFunctionNameFor: squeakSelector).].
	
	assertBlock
		value: 'do:forDuration:' value: 'do_forDuration_';
		value: 'do:' value: 'do_';
		value: 'do' value: '_do';
		value: '*+' value: '_times_plus';
		value: '++' value: '_plus_plus'.! !

!S2JPrinterTest methodsFor: 'test stories' stamp: 'LT 1/4/2011 20:04:49.356'!
testTrueFalse

	self 
		assertMatches: '10 < 5 ifTrue: [ JsGlobal alert: ''small'' ] ifFalse: [ JsGlobal alert: ''big'' ]'
		andProduces:
			'Number(10)._less(Number(5)).ifTrue_ifFalse_(block(function(){return alert("small");}), block(function(){return alert("big");}))'! !

S2JAbstractTest subclass: #S2JSqueakAstToJsAstTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Tests'!

!S2JSqueakAstToJsAstTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:19'!
converterClass
	
	^ S2JSqueakAstToJsAst! !

!S2JSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'LT 1/4/2011 20:48:29.532'!
testBlockArgument
	
	self
		currentRule: #block;
		
		assertMatches: '[]' andProduces: (self node: 'functionCall' with: 
			{nil. 'block'. self node: 'arguments' with: 
				{self node: 'functionDeclaration' with: {self node: 'arguments'. self node: 'functionContent'}}});
		assertMatches: '[1]' andProduces: (self node: 'functionCall' with:  
			{nil. 'block'. self node: 'arguments' with: 
				{self node: 'functionDeclaration' with: 
					{ self node: 'arguments'. 
					self node: 'functionContent' with: 
						{ self node: 'returnExpression' with: 
							{ self node: 'functionCall' with: 
								{ nil. 'Number'. 
								self node: 'arguments' with: 
								{ self node: 'number' with: { 1 }}}}}}}});
		assertMatches: '[^''1'']' andProduces: (self node: 'functionCall' with:  
			{nil. 'block'. self node: 'arguments' with: 
				{self node: 'functionDeclaration' with: 
					{ self node: 'arguments'. 
					self node: 'functionContent' with: 
						{ self node: 'functionCall' with: 
							{ nil.
							'nonLocalReturn'.
							self node: 'arguments' with: 
								{self node: 'string' with: { '1' }}}}}}});
		assertMatches: '[:a]' andProduces: 
		(self node: 'functionCall' with: 
			{nil. 'block'. self node: 'arguments' with: 
				{self node: 'functionDeclaration' with: {self node: 'arguments'  with: { self node: 'identifier' with: { 'a' }}. self node: 'functionContent'}}}).! !

!S2JSqueakAstToJsAstTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!S2JSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'LT 1/4/2011 19:58:28.831'!
testNonLocalReturn
	
	self
		currentRule: #block;
		
		assertMatches: 
			'[ [^ ''returned nonlocally''] value ]'
		 andProduces: (self node: 'functionCall' with: 
			{nil.
			'block'.
			self node: 'arguments' with: 
				{self node: 'functionDeclaration' with: {
					self node: 'arguments' with: {}.
					self node: 'functionContent' with: 
						{self node: 'returnExpression' with: 
						{self node: 'functionCall' with: 
							{ self node: 'functionCall' with: 
								{nil. 
								'block'.
								self node: 'arguments' with: 
									{self node: 'functionDeclaration' with: 
										{self node: 'arguments' with: {}.
										self node: 'functionContent' with: {
											self node: 'functionCall' with: 
												{nil. 'nonLocalReturn'. self node: 'arguments' with: 
													{ self node: 'string' with: {'returned nonlocally'}}}}}}}.
							'value'.
			 				self node: 'arguments' with: {}}}}}}})
		
		
	"expected JavaScript: block(function(){return block(function(){nonLocalReturn('returned nonlocally')}).value() })"! !

!S2JSqueakAstToJsAstTest methodsFor: 'test general' stamp: 'ag 12/13/2010 08:42'!
testRandomMethods
	
	super testRandomMethods! !

S2JTestCase subclass: #S2JCodeFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Squeak2JS-Tests'!

!S2JCodeFactoryTest methodsFor: 'test methods' stamp: 'ag 12/16/2010 11:21'!
aTestMethod
	
	"Empty method for tests"! !

!S2JCodeFactoryTest methodsFor: 'test methods' stamp: 'ag 12/16/2010 11:23'!
aTestMethod2
	
	"Empty method for tests"! !

!S2JCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 11:15'!
codeFactory
	"Skip the singleton-pattern"
	
	^ S2JCodeFactory new! !

!S2JCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 11:21'!
getTestMethod
	
	^ S2JOMeta2 method: #aTestMethod of: self class! !

!S2JCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 11:23'!
getTestMethod2
	
	^ S2JOMeta2 method: #aTestMethod2 of: self class! !

!S2JCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 12/16/2010 21:18'!
testCaching
	
	| factory |
	factory := self codeFactory.
	self assert: factory codeCache size == 0.
	factory codeForMethod: #aTestMethod of: self class.
	self assert: factory codeCache size == 2. "The method and the class"
	factory codeForMethod: #aTestMethod of: self class.
	self assert: factory codeCache size == 2.
	factory codeForMethod: #aTestMethod2 of: self class.
	self assert: factory codeCache size == 3.
	factory codeForClass: self class.
	factory codeFor: self class.
	self assert: factory codeCache size == (self class methodDict size + 1).
	
	factory := self codeFactory.
	factory codeFor: '1 a'.
	self assert: factory codeCache size == 1.
	factory codeFor: '1 a'.
	factory codeFor: '1 a'.
	self assert: factory codeCache size == 1.
	factory codeFor: '1 a; b'.
	factory codeFor: '1 a; b'.
	self assert: factory codeCache size == 2.! !

!S2JCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 12/16/2010 21:20'!
testCachingWithRecompile
	
	| factory size |
	factory := self codeFactory.
	factory codeForClass: self class.
	size := factory codeCache size.
	self class compileAll.
	factory codeForClass: self class.
	self assert: size == factory codeCache size.! !

!S2JCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 12/16/2010 21:14'!
testEqualsBlock
	
	| factory block antiBlock method1 method2 |
	factory := self codeFactory.
	block := [ :o1 :o2 | self assert: (factory compareCacheKey: o1 to: o2)].
	antiBlock := [ :o1 :o2 | self deny: (factory compareCacheKey: o1 to: o2)].
	
	block
		value: 'abc' value: 'abc';
		value: self getTestMethod value: self getTestMethod;
		value: self class value: self class.
	antiBlock
		value: 'abc1' value: 'abc2';
		value: self class value: Object;
		value: 1 value: 2;
		value: 1 value: '1';
		value: self getTestMethod value: (S2JOMeta2 method: #asString of: Object);
		value: self getTestMethod value: self getTestMethod2.
	
	method1 := self getTestMethod.
	self class compileAll.
	method2 := self getTestMethod.
	self deny: method1 == method2. "Should be new objects after recompiling!!"
	block value: method1 value: method2.! !

!S2JTestCase class methodsFor: 'testing' stamp: 'srv 1/5/2011 11:08'!
isOnCIServer
	
	^ true == (Smalltalk at: #S2JisOnCIServer ifAbsent: [ nil ])! !

!S2JTestCase class methodsFor: 'testing' stamp: 'srv 1/5/2011 11:08'!
setIsOnCIServer
	
	Smalltalk at: #S2JisOnCIServer put: true.! !

!S2JTestCase methodsFor: 'private' stamp: 'srv 1/5/2011 11:09'!
timeoutForTest
	"remove test-timeout on the CI-server"
	
	^ self class isOnCIServer
		ifTrue: [ 15 * 60 * 1000 ]
		ifFalse: [ ^ super timeoutForTest ]! !
